datablock ParticleData(DirtParticleC)
{
	dragCoefficient = 0.0;
	gravityCoefficient = -1;
	inheritedVelFactor = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS = 100;
	lifetimeVarianceMS = 75;
	textureName = "base/data/particles/cloud";
	spinSpeed = 30.0;
	spinRandomMin = -50.0;
	spinRandomMax = 50.0;
	useInvAlpha = true;
	colors[0] = "1 0.745 0.50 1";
	colors[1] = "1.50 0.580 0.235 1";
	colors[2] = "0.50 0.250 0.00 1";
	colors[3] = "0.50 0.250 0.00 1";
	sizes[0] = 0.0;
	sizes[1] = 0.0;
	sizes[2] = 0.5;
	sizes[3] = 2.5;
	times[0] = 0.0;
	times[1] = 0.2;
	times[2] = 0.8;
	times[3] = 1.0;
};

datablock ParticleEmitterData(DirtEmitterC)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 25.0;
	velocityVariance = 0.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 5;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	orientOnVelocity = true;

	particles = DirtParticleC; 
};



datablock ExplosionData(DirtPlacerExplosion)
{
	lifeTimeMS = 150;

	particleEmitter = PlayerFoamEmitter;
	particleDensity = 50;
	particleRadius = 0.2;

	faceViewer = true;
	explosionScale = "1 1 1";

	shakeCamera = false;
	camShakeFreq = "10.0 11.0 10.0";
	camShakeAmp = "1.0 1.0 1.0";
	camShakeDuration = 0.5;
	camShakeRadius = 10.0;

	lightStartRadius = 0;
	lightEndRadius = 2;
	lightStartColor = "0.6 0.6 0.9";
	lightEndColor = "0 0 0";
};

datablock ProjectileData(DirtPlacerProjectile)
{
	directDamage = 0;
	directDamageType = $DamageType::ArrowDirect;

	radiusDamage = 0;
	damageRadius = 0;
	radiusDamageType = $DamageType::ArrowDirect;

	explosion = DirtPlacerExplosion;

	muzzleVelocity = 20;
	velInheritFactor = 0;

	armingDelay = 0;
	lifetime = 500;
	fadeDelay = 250;
	bounceElasticity = 0;
	bounceFriction = 0;
	isBallistic = false;
	gravityMod = 0.0;

	hasLight = false;
	lightRadius = 3.0;
	lightColor = "0 0 0.5";
};

datablock ItemData(DirtPlacerItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "base/data/shapes/printGun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Dirt Placer";
	iconName = "base/client/ui/PaintLabel.png";
	doColorShift = true;
	colorShiftColor = "0.50 0.250 0.00 1";

	image = DirtPlacerImage;
	canDrop = false;
};

datablock ShapeBaseImageData(DirtPlacerImage)
{
	shapeFile = "base/data/shapes/printGun.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	correctMuzzleVector = true;

	className = "WeaponImage";

	item = DirtPlacerItem;
	ammo = " ";
	projectile = DirtPlacerProjectile;
	projectileType = Projectile;

	casing = "";
	shellExitDir = "1.0 -1.3 1.0";
	shellExitOffset = "0 0 0";
	shellExitVariance = 15.0;     
	shellVelocity = 7.0;

	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = DirtPlacerItem.colorShiftColor;

	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.15;
	stateTransitionOnTimeout[0] = "Ready";
	stateSound[0] = weaponSwitchSound;
	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1] = true;
	stateSequence[1] = "Ready";
	stateName[2] = "Fire";
	stateTransitionOnTimeout[2] = "Fire";
	stateTransitionOnTriggerUp[2] = "Reload";
	stateTimeoutValue[2] = 1.00;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateSequence[2] = "Fire";
	stateScript[2] = "onFire";
	stateWaitForTimeout[2] = true;
	stateEmitter[2] = DirtEmitterC;
	stateEmitterTime[2] = 0.05;
	stateEmitterNode[2] = "muzzleNode";
	stateSound[2] = sprayFireSound;
	stateEjectShell[2] = true;
	stateName[3] = "Reload";
	stateSequence[3] = "Reload";
	stateTransitionOnTriggerUp[3] = "Ready";
	stateTransitionOnTriggerDown[3] = "Fire";
	stateSequence[3] = "Ready";
};

function DirtPlacerProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	if(!%col.mineable)
		return;
	
	%pos = %col.getPosition();

	%x = getWord(%pos, 0);
	%y = getWord(%pos, 1);
	%z = getWord(%pos, 2);

	if(getWord(%normal,2) == 1) %pos2 = %x SPC %y SPC %z+2;
	if(getWord(%normal,2) == -1) %pos2 = %x SPC %y SPC %z-2;
	if(getWord(%normal,1) == 1) %pos2 = %x SPC %y+2 SPC %z;
	if(getWord(%normal,1) == -1) %pos2 = %x SPC %y-2 SPC %z;
	if(getWord(%normal,0) == 1) %pos2 = %x+2 SPC %y SPC %z;
	if(getWord(%normal,0) == -1) %pos2 = %x-2 SPC %y SPC %z;

	if(vectorDist(%pos2, "0 0 49900") < 20)
	{
		%obj.client.centerPrint("<font:Impact:24>\c6You can't build dirt this close to the spawn!",2);
		%obj.client.play2D(miningErrorSound);
		return;
	}
	if(%obj.client.dirt <= 0)
	{
		%obj.client.centerPrint("<font:Impact:24>\c6You do not have any dirt blocks.",2);
		%obj.client.play2D(miningErrorSound);
		return;
	}
	else
	{
		%obj.client.dirt--;
		placeMiningBlock(%pos2,1,1);
		commandToClient(%obj.client,'ReceiveHUD',"dirt",%obj.client.dirt);
	}
}