datablock ParticleData(dynamiteExplosionParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 900;
	lifetimeVarianceMS	= 300;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	textureName		= "base/data/particles/cloud";
	colors[0]	= "0.3 0.3 0.2 0.9";
	colors[1]	= "0.2 0.2 0.2 0.0";
	sizes[0]	= 4.0;
	sizes[1]	= 7.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(dynamiteExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "dynamiteExplosionParticle";
   uiName = "Dynamite Smoke";
   emitterNode = TenthEmitterNode;
};

datablock ParticleData(dynamiteExplosionParticle2)
{
	dragCoefficient		= 0.1;
	windCoefficient		= 0.0;
	gravityCoefficient	= 2.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	textureName		= "base/data/particles/chunk";
	colors[0]	= "0.0 0.0 0.0 1.0";
	colors[1]	= "0.0 0.0 0.0 0.0";
	sizes[0]	= 0.5;
	sizes[1]	= 0.5;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(dynamiteExplosionEmitter2)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifetimeMS       = 7;
   ejectionVelocity = 15;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "dynamiteExplosionParticle2";
   useEmitterColors = true;
   uiName = "Dynamite Chunk";
   emitterNode = HalfEmitterNode;
};

datablock ExplosionData(dynamiteExplosion)
{
   lifeTimeMS = 150;

   emitter[0] = dynamiteExplosionEmitter;
   emitter[1] = dynamiteExplosionEmitter2;
   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;
   lightStartRadius = 4;
   lightEndRadius = 3;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";
   impulseRadius = 3.5;
   impulseForce = 2000;
   radiusDamage        = 40;
   damageRadius        = 3.5;
};

AddDamageType("SpearDirect",   '<bitmap:add-ons/Weapon_Spear/CI_spear> %1',       '%2 <bitmap:add-ons/Weapon_Spear/CI_spear> %1',1,1);
AddDamageType("SpearRadius",   '<bitmap:add-ons/Weapon_Spear/CI_spearRadius> %1', '%2 <bitmap:add-ons/Weapon_Spear/CI_spearRadius> %1',1,0);

datablock ProjectileData(dynamiteProjectile)
{
   projectileShapeName = "./model/dynamiteProjectile.dts";
   directDamage        = 0;
   directDamageType  = $DamageType::DynamiteDirect;
   radiusDamageType  = $DamageType::DynamiteRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = dynamiteExplosion;
   particleEmitter     = PlayerJetEmitter;
   explodeOnDeath = true;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;
   brickExplosionForce  = 20;
   brickExplosionMaxVolume = 200;
   brickExplosionMaxVolumeFloating = 200;

   muzzleVelocity      = 22;
   velInheritFactor    = 1.0;

   armingDelay         = 10000;
   lifetime            = 10000;
   fadeDelay           = 9500;
   bounceElasticity    = 0.20;
   bounceFriction      = 0.50;
   isBallistic         = true;
   gravityMod          = 2.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "TNT";
};

datablock ItemData(dynamiteItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./model/dynamite.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Dynamite";
	iconName = "./model/Icon_Dynamite";
	doColorShift = false;

	image = dynamiteImage;
	canDrop = true;
};

datablock ShapeBaseImageData(dynamiteImage)
{
   shapeFile = "./model/dynamite.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0"; 
   correctMuzzleVector = true;

   className = "WeaponImage";
   item = dynamiteItem;
   ammo = " ";
   projectile = dynamiteProjectile;
   projectileType = Projectile;
   melee = false;
   armReady = true;
   doColorShift = false;
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.7;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
};

function dynamiteImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}

function dynamiteImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function dynamiteImage::onFire(%this, %obj, %slot)
{

	%obj.playthread(2, spearThrow);
	Parent::onFire(%this, %obj, %slot);

	%obj.client.player.tool[4] = 0;
	%obj.client.player.updateArm(0);
	%obj.client.player.unMountImage(0);
	messageClient(%obj.client,'MsgItemPickup','',4,0);
	serverCmdUnUseTool(%obj.client);

	%obj.client.dynamiteEnabled = 0;
   %obj.client.canBuyDynamite = 0;

	messageAll('',"\c2" @ %obj.client.name SPC "\c6has thrown level" SPC %obj.client.dynamiteLevel SPC "dynamite!");

   schedule(90000,0,dynamiteSpamPrevent,%obj.client);

}

function dynamiteProjectile::onExplode(%this,%obj)
{

	parent::onExplode(%this,%obj);

	%client = %obj.client;

	doExplosion(%obj.getPosition(),%client.dynamiteLevel);

}