datablock AudioProfile(blockHit1)
{
   filename    = "./sound/blockhit/blockhit1.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(blockHit2)
{
   filename    = "./sound/blockhit/blockhit2.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(blockHit3)
{
   filename    = "./sound/blockhit/blockhit3.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(blockHit4)
{
   filename    = "./sound/blockhit/blockhit4.wav";
   description = AudioClosest3d;
   preload = true;
};

function MiningPickaxeProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	mineBlock(%obj,%col,%pos,%normal);
	serverPlay3d(blockHit @ getRandom(1,4),%pos);

	if(%col.player && !%col.bl_id)
		%col.player.addHealth(-5);

	//if(%col.player.getClassName $= "AIPlayer" && %col.player.dataBlock.maxDamage - %col.player.getDamageLevel() <= 0)
	if(isObject(%col) && %col.getClassName() $= "AIPlayer" && %col.player.dataBlock.maxDamage - %col.player.getDamageLevel() <= 0)
	{
		%obj.client.heatsuits = math_Add(%obj.client.heatsuits,getRandom(1,3));
		%obj.client.dirt = math_Add(%obj.client.dirt,getRandom(25,40));
		if(!getRandom(0,%obj.client.dynamiteLevel*4 + 20))
		{
			%obj.client.player.tool[4] = dynamiteItem.getID();
			messageClient(%obj.client,'MsgItemPickup','',4,dynamiteItem.getID());
			%obj.client.centerPrint("<font:Impact:24>\c6The zombie dropped a dynamite!");
		}
		sendGUICommand(%obj.client,"heatsuit");
		sendGUICommand(%obj.client,"dirt");
	}
}

function MiningUltimatePickaxeProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	MiningPickaxeProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal);
}

datablock projectileData(MiningPickaxeProjectile : hammerProjectile)
{
	directDamage = 5;
	lifeTime = 150;
	explodeOnDeath = false;
	explosion = PickaxeExplosion;
};

datablock projectileData(MiningUltimatePickaxeProjectile : hammerProjectile)
{
	hasLight    = true;
	lightRadius = 3.0;
	lightColor  = "1 1 1";

	directDamage = 10;
	lifeTime = 1500;
	explodeOnDeath = false;
	explosion = UltimatePickaxeExplosion;
};

datablock ExplosionData(PickaxeExplosion)
{
	lifeTimeMS = 150;

	particleEmitter = HammerExplosionEmitter;
	particleDensity = 3;
	particleRadius = 0.13;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "7.0 8.0 7.0";
	camShakeAmp = "0.3 0.3 0.3";
	camShakeDuration = 0.5;
	camShakeRadius = 4.0;

	lightStartRadius = 2;
	lightEndRadius = 0;
	lightStartColor = "0.6 0.6 0.6";
	lightEndColor = "0 0 0";
};

datablock ExplosionData(UltimatePickaxeExplosion)
{
	lifeTimeMS = 200;

	particleEmitter = HammerExplosionEmitter;
	particleDensity = 3;
	particleRadius = 0.13;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "7.0 8.0 7.0";
	camShakeAmp = "0.3 0.3 0.3";
	camShakeDuration = 0.5;
	camShakeRadius = 4.0;

	lightStartRadius = 5;
	lightEndRadius = 0;
	lightStartColor = "0.8 0.8 0.8";
	lightEndColor = "0 0 0";
};

datablock itemData(MiningPickaxeItem : hammerItem)
{
	shapeFile = "./model/pickaxe.dts";
	uiName = "Pickaxe";
	image = MiningPickaxeImage;
	iconName = "./model/Icon_Pickaxe";
	colorShiftColor = "0.000000 0.000000 0.800000 1.000000";
};

datablock shapeBaseImageData(MiningPickaxeImage : hammerImage)
{
	shapeFile = "./model/pickaxe.dts";
	item = MiningPickaxeItem;
	projectile = MiningPickaxeProjectile;
	colorShiftColor = "0.000000 0.000000 0.800000 1.000000";
	minShotTime = 110;
	stateTimeoutValue[1] = 0;
	stateTimeoutValue[2] = 0.01;
	stateTimeoutValue[3] = 0.18;
	stateTimeoutValue[4] = 0;
	stateTimeoutValue[5] = 0.18;
	stateTimeoutValue[6] = 0;
	rotation = eulerToMatrix( "0 0 0" );
	mountPoint = 0;
	offset = "0 0 0";
	emap = true;
	eyeOffset = "0 0 0";
};

datablock itemData(MiningSuperPickaxeItem : hammerItem)
{
	shapeFile = "./model/pickaxe.dts";
	uiName = "Super Pickaxe";
	image = MiningSuperPickaxeImage;
	iconName = "./model/Icon_Pickaxe";
	colorShiftColor = "0.800000 0.000000 0.000000 1.000000";
};

datablock shapeBaseImageData(MiningSuperPickaxeImage : hammerImage)
{
	shapeFile = "./model/pickaxe.dts";
	item = MiningSuperPickaxeItem;
	projectile = MiningPickaxeProjectile;
	colorShiftColor = "0.800000 0.000000 0.000000 1.000000";
	minShotTime = 10;
	stateTimeoutValue[1] = 0;
	stateTimeoutValue[2] = 0.01;
	stateTimeoutValue[3] = 0.08;
	stateTimeoutValue[4] = 0;
	stateTimeoutValue[5] = 0.08;
	stateTimeoutValue[6] = 0;
	rotation = eulerToMatrix( "0 0 0" );
	mountPoint = 0;
	offset = "0 0 0";
	emap = true;
	eyeOffset = "0 0 0";
};

datablock itemData(MiningUltimatePickaxeItem : hammerItem)
{
	shapeFile = "./model/pickaxe.dts";
	uiName = "Ult. Pickaxe";
	image = MiningUltimatePickaxeImage;
	iconName = "./model/Icon_Pickaxe";
	colorShiftColor = "0.200000 0.800000 0.300000 1.000000";
};

datablock shapeBaseImageData(MiningUltimatePickaxeImage : hammerImage)
{
	shapeFile = "./model/pickaxe.dts";
	item = MiningUltimatePickaxeItem;
	projectile = MiningUltimatePickaxeProjectile;
	colorShiftColor = "0.200000 0.800000 0.300000 1.000000";
	minShotTime = 5;
	stateTimeoutValue[1] = 0;
	stateTimeoutValue[2] = 0.01;
	stateTimeoutValue[3] = 0.05;
	stateTimeoutValue[4] = 0;
	stateTimeoutValue[5] = 0.05;
	stateTimeoutValue[6] = 0;
	rotation = eulerToMatrix( "0 0 0" );
	mountPoint = 0;
	offset = "0 0 0";
	emap = true;
	eyeOffset = "0 0 0";
};

datablock AudioProfile(pickSwing1)
{
   filename    = "./sound/pickswing/pickswing1.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(pickSwing2)
{
   filename    = "./sound/pickswing/pickswing2.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(pickSwing3)
{
   filename    = "./sound/pickswing/pickswing3.wav";
   description = AudioClosest3d;
   preload = true;
};

function MiningPickaxeImage::onFire(%this,%obj,%slot)
{
	parent::onFire(%this,%obj,%slot);

	serverPlay3D(pickSwing @ getRandom(1,3),%obj.getPosition());

	%obj.playThread(2,"armAttack");
	%obj.lastFireTime = getSimTime();
}

function MiningPickaxeImage::onStopFire(%this,%obj,%slot)
{
	%obj.playThread(2,"root");
}

function MiningSuperPickaxeImage::onFire(%this,%obj,%slot) { MiningPickaxeImage::onFire(%this,%obj,%slot); }
function MiningSuperPickaxeImage::onStopFire(%this,%obj,%slot) { MiningPickaxeImage::onStopFire(%this,%obj,%slot); }
function MiningUltimatePickaxeImage::onFire(%this,%obj,%slot) { MiningPickaxeImage::onFire(%this,%obj,%slot); }
function MiningUltimatePickaxeImage::onStopFire(%this,%obj,%slot) { MiningPickaxeImage::onStopFire(%this,%obj,%slot); }