//Pickaxe and dynamite created by Zapk.
//Improved math system created by Ipquarx.
$Mining::Root = "Add-Ons/GameMode_EndlessMining/";
$Mining::GUIVer = 3.0;

datablock AudioProfile(explosionSound)
{
   filename    = "./sound/explode.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(miningErrorSound)
{
   filename    = "./sound/error.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(buyItemSound)
{
   filename    = "./sound/buyitem.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(levelUpSound)
{
   filename    = "./sound/levelup.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(blockPlaceSound)
{
   filename    = "./sound/blockplace.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(ambience_1)
{
	fileName = "./sound/ambience/ambience1.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(ambience_2)
{
	fileName = "./sound/ambience/ambience2.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(ambience_3)
{
	fileName = "./sound/ambience/ambience3.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(ambience_4)
{
	fileName = "./sound/ambience/ambience4.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(ambience_5)
{
	fileName = "./sound/ambience/ambience5.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(ambience_6)
{
	fileName = "./sound/ambience/ambience6.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(ambience_7)
{
	fileName = "./sound/ambience/ambience7.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(ambience_8)
{
	fileName = "./sound/ambience/ambience8.wav";
	description = AudioClosest3d;
	preload = true;
};

datablock AudioProfile(ambience_death)
{
	fileName = "./sound/death.wav";
	description = AudioClosest3d;
	preload = true;
};

if(!isObject(publicClient))
{
    new AiConnection(publicClient) { BL_ID = 888888; };
    publicClient.isAdmin = true;
    publicClient.isSuperAdmin = true;
}


exec($Mining::Root @ "math.cs");
noticeMessage("Initiated Ipquarx's improved math system.");

function noticeMessage(%msg)
{
	announce("Serverbot 1.4\c6: " SPC %msg);
	echo(%msg);
}

function doRevisionNumber()
{
	%file = new FileObject();
	%filename = $Mining::Root @ "version";

	if(isFile(%filename))
	{
		%file.openForRead(%filename);
		%rev = %file.readLine();
		%file.close();
	}
	if(getNumKeyID() == 18701 && isFile(%filename))
	{
		%rev++;

		%file.openForWrite(%filename);
		%file.writeLine(%rev);
		%file.close();

		noticeMessage("Endless Mining r" @ %rev);

		$Pref::Server::Name = "[Dev] Endless Mining r" @ %rev;
	}

	$MiningRev = %rev;

	%file.close();
	%file.delete();
}
doRevisionNumber();

function convertRGBToHex(%dec)
{
	%str = "0123456789ABCDEF";

	while(%dec != 0)
	{
		%hexn = %dec % 16;
		%dec = mFloor(%dec / 16);
		%hex = getSubStr(%str,%hexn,1) @ %hex;    
	}

	if(strLen(%hex) == 1)
		%hex = "0" @ %hex;
	if(!strLen(%hex))
		%hex = "00";

	return %hex;
}

function getCommaNumber(%num,%dec)
{
	//math.cs now required
	if(%dec)
	{
		if(getDecimal(%num) != -1)
		{
			%decimals = getSubStr(getDecPart(%num),0,strLen(getDecPart(%num)));
			%num = getSubStr(%num,0,getDecimal(%num));
		}
		while(strLen(%decimals) != 2)
			%decimals = %decimals @ "0";
		%decimals = "." @ %decimals;
	}

	%length = strLen(%num);

	if(%length < 4)
		return %num @ %decimals;

	for(%i = %length - 3; %i > 0; %i -= 3)
		%string = "," @ getSubStr(%num, %i, 3) @ %string;
	%i += 3;
	%string = getSubStr(%num, 0, %i) @ %string;

	return %string @ %decimals;
}

function miningInit()
{
	$Mining::Root = "Add-Ons/GameMode_EndlessMining/";

	if($Mining::HasStarted)
		return noticeMessage("Gamemode already initiated.");
	else
		$Mining::HasStarted = 1;

	//$Mining::Host = new ScriptObject() 
	//{
	//	isAdmin = 1;
	//	brickgroup = 0;
	//	bl_id = getNumKeyID();
	//};
	//%brickgroup = new SimGroup("BrickGroup_" @ getNumKeyID())
	//{
	//	client = 0;
	//	bl_id = getNumKeyID();
	//	name = "The Host";
	//};

	//$Mining::Host.brickgroup = %brickgroup;
	//mainBrickGroup.add($Mining::Host.brickgroup);

	noticeMessage("Starting init commands...");
	cancel($Mining::AutoSave);
	getOres();
	getDirts();
	newSpawn();
	miningLoop();
	miningAutoSave();

	noticeMessage("Setting datablock properties...");
	swordProjectile.directDamage = 12;
	playerStandardArmor.maxTools = 7;
	playerStandardArmor.maxWeapons = 7;

	exec($Mining::Root @ "override.cs");
	cancel($MiningReset);

	%file = new FileObject();
	%file.openForRead("config/server/EndlessMining/DB/highscore");
	%line = %file.readLine();
	$Mining_p::HighScore[0] = getField(%line,0);
	$Mining_p::HighScore[1] = getField(%line,1);
	%file.close();
	%file.delete();
	noticeMessage("Loaded the highscore...");
}

exec($Mining::Root @ "saving.cs");
noticeMessage("Save system has been loaded.");

function getOres()
{
	if(isFile("config/server/EndlessMining/ores.txt"))
		%filename = "config/server/EndlessMining/ores.txt";
	else
		%filename = $Mining::Root @ "ores.txt";

	if(!isFile(%filename))
		return echo("You're missing the ores database! (ores.txt)");

	if(isObject(Ores))
	{
		for(%i=0;%i<Ores.getCount();%i++)
			Ores.getObject(%i).delete();

		Ores.delete();
	}

	new SimSet(Ores) { name = "Ores"; };

	if(isFile(%filename))
	{
		%file = new FileObject();
		%file.openForRead(%filename);

		%ID = 0;
		while(!%file.isEOF())
		{
			%ID += 1;

			%line = %file.readLine();
			if(getSubStr(%line,0,2) $= "--")
				continue;

			%ore = new ScriptObject(OreBlockData)
			{
				name = getField(%line,0);
				value = getField(%line,1);
				health = getField(%line,2);
				minZ = getField(%line,3);
				maxZ = getField(%line,4);
				color = getField(%line,5);
				minlevel = getField(%line,6);
				weight = getField(%line,7);
				colorfx = getField(%line,8);
				owner = getField(%line,9);
				ID = %ID;
			};
			Ores.add(%ore);
		}
		%file.close();
		%file.delete();
	}
	noticeMessage("Gathered ores from the DB.");
}

function getDirts()
{
	%filename = $Mining::Root @ "dirts.txt";

	if(!isFile(%filename))
		return echo("You're missing the dirts database! (dirts.txt)");

	if(isObject(Dirts))
	{
		for(%i=0;%i<Dirts.getCount();%i++)
			Dirts.getObject(%i).delete();

		Dirts.delete();
	}

	new SimSet(Dirts) { name = "Dirts"; };

	if(isFile(%filename))
	{
		%file = new FileObject();
		%file.openForRead(%filename);
		while(!%file.isEOF())
		{
			%line = %file.readLine();
			if(getSubStr(%line,0,2) $= "--")
				continue;

			%dirt = new ScriptObject(DirtBlockData)
			{
				name = getField(%line,0);
				health = getField(%line,1);
				minZ = getField(%line,2);
				maxZ = getField(%line,3);
				color = getField(%line,4);
				minlevel = getField(%line,5);
			};
			Dirts.add(%dirt);
		}
		%file.close();
		%file.delete();
	}
	noticeMessage("Gathered dirts from the DB.");
}

function newSpawn()
{
	%spawn = playerDropPoints.getObject(0);
	%spawn.delete();

	placeMiningBlock("0 0 49900",1);
	schedule(300,0,buildSpawn,getRandom(10,20));

	%spawn = new SpawnSphere()
	{
		rotation = "1 0 0 0";
		scale = "1 1 1";
		position = "0 0 49900";
		dataBlock = "SpawnSphereMarker";
		radius = 5;
		sphereWeight = 1;
		indoorWeight = 1;
		outdoorWeight = 1;
		RayHeight = 3;
	};
	PlayerDropPoints.add(%spawn);

	for(%i=0;%i<clientGroup.getCount();%i++)
	{
		%player = clientGroup.getObject(%i).player;
		if(isObject(%player))
			%player.instantRespawn();
	}
	noticeMessage("Spawn area initiated.");
}

function buildSpawn(%radius)
{
	noticeMessage("Building spawn area...");

	for(%i=-2;%i<3;%i++)
		for(%j=-2;%j<3;%j++)
			placeMiningBlock(%i*2 SPC %j*2 SPC "49892",3);

	placeMiningBlock("-4 -4 49894",4);
	placeMiningBlock("-4 4 49894",4);
	placeMiningBlock("4 -4 49894",4);
	placeMiningBlock("4 4 49894",4);

	for(%i=0;%i<%radius;%i++)
	{
		InitContainerRadiusSearch("0 0 49900",%radius,$TypeMasks::FXBrickObjectType);

		while((%targetObject = containerSearchNext()) !$= 0)
		{
			if(!%targetObject.invincible)
			{
				checkMiningBlock(%targetObject.getPosition(),1);
				%targetObject.delete();
			}
		}
	}
	noticeMessage("Spawn area built.");
}

function doExplosion(%position,%radius,%preventspam)
{
	serverPlay3d(explosionSound,%position);
	%radius += 5;

	for(%i=0;%i<%radius;%i++)
	{
		getExplosionDelay(%radius,%i,%preventspam);
		schedule($Mining::ExplosionDelay,0,doExplosion_Step,%position,%radius,%i);
	}

	$Mining::ExplosionsInProgress++;
	$Mining::HasWarned_ExDe = 0;
}

function getExplosionDelay(%radius,%i,%preventspam)
{
	//if((10*%radius)+($Mining::ExplosionsInProgress*100) && !$Mining::HasWarned_ExDe)
	$Mining::ExplosionDelay = ((25*%radius)*(%i+1))+($Mining::ExplosionsInProgress*100);
	if(!$Mining::HasWarned_ExDe && !%preventspam)
	{
		messageAll('',"\c6Explosions are updating at" SPC $Mining::ExplosionDelay SPC "ms.");
		$Mining::HasWarned_ExDe = 1;
	}
}

function doExplosion_Step(%position,%radius,%i)
{
	InitContainerRadiusSearch(%position,%radius,$TypeMasks::FXBrickObjectType);
	while((%targetObject = containerSearchNext()) != 0)
	{
		if(!%targetObject.invincible && %targetObject.mineable && !%targetObject.buildArea)
		{
			checkMiningBlock(%targetObject.getPosition());
			if(getSimTime() - %targetObject.lastOwnerTime >= 7500 || %targetObject.type $= "Dormant Bomb")
				%targetObject.delete();
		}
	}
	if(%radius - %i == 1)
		$Mining::ExplosionsInProgress--;
}

function Block_getDirt(%position)
{
	%zpos = getWord(%position,2);

	for(%i=0;%i<Dirts.getCount();%i++)
	{
		%dirt = Dirts.getObject(%i);
		if(%zpos >= %dirt.minZ && %zpos <= %dirt.maxZ)
			break;
	}
	return %dirt;
}

function Block_getOre(%position)
{
	%zpos = getWord(%position,2);
	$j = 0;

	for(%i=0;%i<Ores.getCount();%i++)
	{
		%ore = Ores.getObject(%i);
		if(%zpos >= %ore.minZ && %zpos < %ore.maxZ)
		{
			for(%j=0;%j<%ore.weight;%j++)
			{
				$j++;
				%choice[$j] = %ore;
				%totalweight += 1;
			}
		}
	}

	%chosen = getRandom(1,%totalweight);

	if(%choice[%chosen].name $= "Moonstone")
	{
		if(getRandom(0,125) != 4)
			return %choice[getRandom(1,%totalweight-2)];
		else
			return %choice[%chosen];
	}
	else
		return %choice[%chosen];
}

function checkMiningBlock(%position,%spawn)
{
	%xpos = getWord(%position,0);
	%ypos = getWord(%position,1);
	%zpos = getWord(%position,2);

	//left and right blocks
	%position[0] = %xpos + 2 SPC %ypos SPC %zpos;
	%position[1] = %xpos - 2 SPC %ypos SPC %zpos;
	//front and behind blocks
	%position[2] = %xpos SPC %ypos + 2 SPC %zpos;
	%position[3] = %xpos SPC %ypos - 2 SPC %zpos;
	//above and below blocks
	%position[4] = %xpos SPC %ypos SPC %zpos + 2;
	%position[5] = %xpos SPC %ypos SPC %zpos - 2;

	for(%i=0;%i<6;%i++)
	{
		if(!$Mining::Block[%position[%i]])
		{
			if(%zpos <= 50000 && getRandom(0,mCeil(%zpos/180)+4) == 5)
				%type = 5;
			if(getRandom(1,12) == 3)
				%type = 2;
			else if(%type != 5)
				%type = 1;
			if(getRandom(0,1850) == 5)
				%type = 6;
			if(getRandom(0,2250) == 5)
				%type = 8;
			if(getRandom(0,2750) == 5)
				%type = 10;

			if(!%spawn)
				placeMiningBlock(%position[%i],%type);
			else
				placeMiningBlock(%position[%i],1);
		}
	}
}

function getRadiation(%position)
{
	if(getWord(%position,2) > 16000)
		return 0;
	if(getRandom(0,10) == 3)
		return 1;
	else
		return 0;
}

function placeMiningBlock(%position,%type,%placer,%client)
{
	if($Mining::Block[%position] && !%placer)
		return;
	
	switch(%type)
	{
		case 1: //Dirt
			%dirt = Block_getDirt(%position);
			%color = %dirt.color;
			%type = %dirt.name;
			%minlevel = %dirt.minlevel;
			%health = %dirt.health + mFloor(getRandom(%minlevel/2 - 3,%minlevel/2 + 3));
			%radiated = getRadiation(%position);

		case 2: //Ore
			%ore = Block_getOre(%position);
			%color = %ore.color;
			%colorfx = %ore.colorfx;
			%type = %ore.name;
			%minlevel = %ore.minlevel;
			%health = %ore.health + mFloor(getRandom(%minlevel/2 - 3,%minlevel/2 + 3));
			%value = %ore.value + mFloor(getRandom(%minlevel/2 - 3,%minlevel/2 + 3));
			%weight = %ore.weight;
			%radiated = getRadiation(%position);

		case 3: //Why even name an invincible brick
			%color = 4;
			%invincible = 1;
			%type = "Cement";

		case 4: //Spawn lights
			%color = 21;
			%invincible = 1;
			%light = 1;
			%type = "Spawn light";

		case 5: //Lava
			%color = 38;
			%colorfx = 3;
			%type = "Lava";
			%health = 5;
			%touch = 1;

		case 6: //Dormant bombs
			%color = 39;
			%colorfx = 3;
			%type = "Dormant Bomb";
			%health = getRandom(50,150);
			%minlevel = mFloor(%health/30);

		case 7: //Lanterns
			%color = 21;
			%type = "Lantern";
			%health = 1;
			%light = 1;
			%planter = %client.bl_id;

		case 8: //Chance block
			%color = 40;
			%colorfx = 3;
			%type = "Chance Block";
			%health = getRandom(250,750);
			%minlevel = 7;
			%strength = getRandom(2,4);

		case 9: //Building area
			%color = 19;
			%type = "Building Area";
			%planter = %client;
			%buildarea = 1;
			%health = 20;

		case 10: //Sunlight block
			%color = 19;
			%colorfx = 3;
			%type = "Sunlight Block";
			%health = 350;
			%minlevel = 7;
			%light = 2;
	}

	if(!%placer)
	{
		if(%radiated)
		{
			%rand = getRandom(8,12);
			%health = %health * %rand;
			if(%value)
				%value = %value * %rand;
			%minlevel += %rand;
			%shapefx = 1;
		}
	}

	%brick = new fxDTSBrick()
	{
		client = 888888;
		dataBlock = "brick4xCubeData";
		position = %position;
		rotation = "0 0 0 0";
		colorID = %color;
		scale = "1 1 1";
		angleID = 0;
		colorfxID = %colorfx;
		shapefxID = %shapefx;
		isPlanted = 1;
		stackBL_ID = 888888;
		type = %type;
		health = %health;
		maxhealth = %health;
		invincible = %invincible;
		value = %value;
		minlevel = %minlevel;
		weight = %weight;
		enableTouch = %touch;
		radiated = %radiated;
		strength = %strength;
		buildarea = %buildarea;
		planter = %planter;
		mineable = 1;
		created = getSimTime();
	};
	%brick.plant();
	%brick.setTrusted(1);

	if(%light == 1)
	{
		%brick.setLight(LanternLight);
		if(%invincible)
			%brick.setLight(PlayerLight);
	}
	if(%light == 2)
		%brick.setLight(YellowLight);
	if(%type == 7)
		$Mining::Lantern[%client.bl_id] = %brick;

	//$Mining::Host.brickgroup.add(%brick);
	BrickGroup_888888.add(%brick);
	$Mining::Block[%position] = %brick;

	serverPlay3d(blockPlaceSound,%position);
}

function activateBuff(%client,%which,%strength,%time,%position)
{
	%client.buff = 1;

	switch(%which)
	{
		case 1:
			%client.play2D(levelUpSound);
			%client.valueBuff = %strength;
			return messageClient(%client,'',"\c6All ores and dirt for the next" SPC %time/60000 SPC "minute(s) are worth" SPC %strength SPC "times as much.");

		case 2:
			%client.play2D(levelUpSound);
			%client.strengthBuff = %strength;
			return messageClient(%client,'',"\c6Your pickaxe is now" SPC %strength SPC "times stronger for the next" SPC %time/60000 SPC "minute(s).");

		case 3:
			%spawnBrick = new fxDTSBrick()
			{
				client = $Mining::Host;
				dataBlock = "BrickZombie_HoleSpawnData";
				position = "0 0 -100";
				rotation = "0 0 0 0";
				scale = "1 1 1";
				isPlanted = 1;
				stackBL_ID = $Mining::Host.bl_id;
				isBotHole = 1;
			};

			%spawnBrick.plant();
			%spawnBrick.setTrusted(1);

			//$Mining::Host.brickgroup.add(%spawnBrick);
			BrickGroup_888888.add(%spawnBrick);

			if(getWord(%position,2) <= 15000)
			{
				schedule(33,0,miningSpawnBot,%spawnBrick,%position,2);
				schedule(66,0,miningSpawnBot,%spawnBrick,%position,2);
				schedule(99,0,miningSpawnBot,%spawnBrick,%position,2);
				schedule(132,0,miningSpawnBot,%spawnBrick,%position,2);
				schedule(165,0,miningSpawnBot,%spawnBrick,%position,2);
			}
			else
			{
				schedule(33,0,miningSpawnBot,%spawnBrick,%position,1);
				schedule(66,0,miningSpawnBot,%spawnBrick,%position,1);
				schedule(99,0,miningSpawnBot,%spawnBrick,%position,1);
				schedule(132,0,miningSpawnBot,%spawnBrick,%position,1);
				schedule(165,0,miningSpawnBot,%spawnBrick,%position,1);
			}

			%client.play2D(levelUpSound);

			deactivateBuff(%client);

			return messageClient(%client,'',"\c6Have a zombie party! Yay zombie parties!");

		case 4:
			%client.heatsuits += getRandom(5,15);
			%client.dirt += getRandom(50,75);
			%client.radsuits += getRandom(3,6);

			sendGUICommand(%client,"dirt");
			sendGUICommand(%client,"radsuit");
			sendGUICommand(%client,"heatsuit");

			deactivateBuff(%client);
			return messageClient(%client,'',"Have some supplies. On me, too!");
	}
}

function deactivateBuff(%client)
{
	if(%client.buff)
	{
		%client.buff = 0;
		%client.valueBuff = 1;
		%client.strengthBuff = 1;

		messageClient(%client,'',"\c6Your buff has worn off.");
	}
}

function serverCmdToggleAutoLevel(%client)
{
	if(%client.autoLevel)
	{
		%client.autoLevel = 0;
		%client.centerPrint("<font:Impact:24>Automatic pickaxe levelling disabled.");
	}
	else
	{
		%client.autoLevel = 1;
		%client.centerPrint("<font:Impact:24>Automatic pickaxe levelling enabled.");
	}
}

function mineBlock(%obj,%col,%pos)
{
	if(%col.mineable)
	{
		if(!%col.invincible)
		{
			if(%obj.client.bl_id != 999999)
			{
				if(%col.planter && %col.stackBL_ID != %obj.client.bl_id)
				{
					%obj.client.centerPrint("<font:Impact:24>\c6You do not own this block.",2);
					%obj.client.play2D(miningErrorSound);
					return;
				}

				if(%col.lastOwner == %obj.client)
					%col.lastOwnerTime = getSimTime();
				else if(getSimTime() - %col.lastOwnerTime >= 7500)
				{
					%col.lastOwner = %obj.client;
					%col.lastOwnerTime = getSimTime();
				}
				else if(%col.lastOwner !$= "")
				{
					//not in the same if check so it's not spitting out errors.
					if(!getTrustLevel(%obj.client,%col.lastOwner))
					{
						%obj.client.centerPrint("<font:Impact:24>\c6" @ %col.lastOwner.name SPC "does not trust you enough to mine this block.",2);
						%obj.client.play2D(miningErrorSound);
						return;
					}
				}
			}

			if(%obj.client.buff && %col.strength)
			{
				%obj.client.centerPrint("<font:Impact:24>\c6You're already under the effect of a buff, wait for it to wear off!",2);
				%obj.client.play2D(miningErrorSound);
				return;
			}

			%color = convertRGBtoHex(mFloor(getWord(getColorIdTable(%col.colorID),0) * 255));
			%color = %color @ convertRGBtoHex(mFloor(getWord(getColorIdTable(%col.colorID),1) * 255));
			%color = %color @ convertRGBtoHex(mFloor(getWord(getColorIdTable(%col.colorID),2) * 255));
			%color = "<color:" @ %color @ ">";

			if(%col.radiated)
				%type = "Radiated" SPC %col.type;
			else
				%type = %col.type;


			if(%obj.client.level < %col.minlevel)
			{
				%obj.client.centerPrint("<font:Impact:24>\c6You need to be at least level" SPC %col.minlevel SPC "to mine" @ %color SPC %col.type @ ".",2);
				%obj.client.play2D(miningErrorSound);
				return;
			}
			else
			{
				if(!%obj.client.strengthBuff)
					%obj.client.strengthBuff = 1;

				%col.health -= %obj.client.level * %obj.client.strengthBuff;
			}

			%age = getAge(%col,0);
			%agef = getAge(%col,1);

			if(%col.health <= 0)
			{
				if(%col.type $= "Building Area")
				{
					if(%col.getNumUpBricks() != 0)
					{
						%obj.client.centerPrint("<font:Impact:24>\c6There appears to be bricks on top, please remove them first.",3);
						%obj.client.play2D(MiningErrorSound);
						return;
					}

					%secondLine = "<font:Impact:20>\c2+$250";
					
					//%obj.client.cash += 250;
					%obj.client.cash = math_Add(%obj.client.cash,250);
					if(%obj.client.GUI)
						commandToClient(%obj.client,'ReceiveHUD',"cash",%obj.client.cash);
				}

				if(%col.value)
				{
					if(!%obj.client.valueBuff)
						%obj.client.valueBuff = 1;

					//%obj.client.cash += %col.value * %obj.client.valueBuff;
					//%obj.client.points += %col.value;
					//%obj.client.cash = math_Add(%obj.client.cash,%col.value * %obj.client.valueBuff);
					%cost = getWeightedCost(%obj,%col);
					%obj.client.cash = math_Add(%obj.client.cash,%cost);
					%obj.client.points = math_Add(%obj.client.points,%col.value);
					if(%obj.client.GUI)
					{
						sendGUICommand(%obj.client,"cash");
						sendGUICommand(%obj.client,"points");
					}

					%secondLine = "<font:Impact:20>\c2+$" @ getCommaNumber(%cost,1);
				}
				else
				{
					if(!%obj.client.valueBuff)
						%obj.client.valueBuff = 1;

					//%obj.client.dirt += %obj.client.valueBuff;
					//%obj.client.points++;
					%obj.client.dirt = math_Add(%obj.client.dirt,%obj.client.valueBuff);
					%obj.client.points = math_Add(%obj.client.points,1);
					if(%obj.client.GUI)
					{
						sendGUICommand(%obj.client,"dirt");
						sendGUICommand(%obj.client,"points");
					}

					if(%obj.client.pickaxe == 2 && getRandom(0,35) == 2 && %obj.client.UTExplosion)
						%explosion = 1;
				}

				if(%col.type $= "Sunlight Block")
					doSunlight(%obj.client);

				if(%col.value)
					%obj.client.centerPrint("<font:Impact:24>" @ %color @ %type @ "<color:ffffff>: 0/" @ getCommaNumber(%col.maxhealth) @ "<br><font:Impact:18>\c4Age:\c6" SPC %agef @ "<br>" @ %secondLine,2);
				else
					%obj.client.centerPrint("<font:Impact:24>" @ %color @ %type @ "<color:ffffff>: 0/" @ getCommaNumber(%col.maxhealth));

				if(%col.type $= "Lava")
				{
					if(%obj.client.heatsuits <= 0)
					{
						messageAll('',"\c2" @ %obj.client.name SPC "\c6mined lava!");

						//%obj.client.cash -= getRandom(175,225);
						//%obj.client.cash = math_Subtract(%obj.client.cash,getRandom(175,225));
						%obj.client.cash = math_Subtract(%obj.client.cash,getRandom(1,3));
						%obj.client.player.kill();
						if(%obj.client.GUI)
							commandToClient(%obj.client,'ReceiveHUD',"cash",%obj.client.cash);
					}
					else
					{
						%obj.client.heatsuits--;
						if(%obj.client.GUI)
							commandToClient(%obj.client,'ReceiveHUD',"heatsuit",%obj.client.heatsuits);
					}
				}

				if(%col.radiated)
				{
					if(%obj.client.radsuits <= 0)
					{
						if(getRandom(0,8) == 3)
						{
							messageAll('',"\c2" @ %obj.client.name SPC "\c6didn't have enough protection from radiation.");
							%obj.client.player.kill();
							//%obj.client.cash -= %col.value;
							%obj.client.cash = math_Subtract(%obj.client.cash,%col.value);
						}
					}
					else
					{
						%obj.client.radsuits--;
						if(%obj.client.GUI)
							commandToClient(%obj.client,'ReceiveHUD',"radsuit",%obj.client.radsuits);
					}
				}

				if(%col.type $= "Dormant Bomb" && !%col.hasExploded)
				{
					serverPlay3d(explosionSound,%col.getPosition());
					doExplosion(%col.getPosition(),getRandom(0,9));
					%col.hasExploded = 1;
					return messageAll('',"\c2" @ %obj.client.name SPC "\c6set off a dormant bomb!");
				}
				if(%col.hasExploded)
					return;
				//else
				//	return;

				%zpos = mFloor(getWord(%col.getPosition(),2)/120);
				if(%zpos < 100)
					%zpos = 100;
				//noticeMessage(%zpos);

				if(getRandom(1,%zpos) == 5)
				{
					%spawnBrick = new fxDTSBrick()
					{
						client = $Mining::Host;
						dataBlock = "BrickZombie_HoleSpawnData";
						//dataBlock = "RadBrickZombie_HoleSpawnData";
						position = "0 0 -100";
						rotation = "0 0 0 0";
						colorID = 0;
						scale = "1 1 1";
						angleID = 0;
						colorfxID = 0;
						shapefxID = 0;
						isPlanted = 1;
						stackBL_ID = $Mining::Host.bl_id;
						isBotHole = 1;
					};

					%spawnBrick.plant();
					%spawnBrick.setTrusted(1);

					//$Mining::Host.brickgroup.add(%spawnBrick);
					BrickGroup_888888.add(%spawnBrick);

					%colPos = %col.getPosition();
					if(%zpos <= 150)
						schedule(33,0,miningSpawnBot,%spawnBrick,%colPos,2);
					else
						schedule(33,0,miningSpawnBot,%spawnBrick,%colPos,1);
				}

				if(%col.strength > 0)
				{
					%obj.client.buff = 1;
					%time = getRandom(1,2)*60000;

					activateBuff(%obj.client,getRandom(1,4),%col.strength,%time,%col.getPosition());
					schedule(%time,0,deactivateBuff,%obj.client);
				}

				if(%obj.client.autoLevel && %obj.client.cash >= %obj.client.cost)
					serverCmdUpgradePick(%obj.client,1);

				if(%explosion)
					doExplosion(%col.getPosition(),getRandom(-3,-1),1);

				checkMiningBlock(%col.getPosition());
				//serverPlay3d(blockPlaceSound,%pos);
				%col.delete();
				
			}
			else
			{
				if(%col.value)
					%obj.client.centerPrint("<font:Impact:24>" @ %color @ %type @ "<color:ffffff>: " @ getCommaNumber(%col.health) @ "/" @ getCommaNumber(%col.maxhealth) @ "<br><font:Impact:18>\c4Age:\c6" SPC %agef,1);
				else
					%obj.client.centerPrint("<font:Impact:24>" @ %color @ %type @ "<color:ffffff>: " @ getCommaNumber(%col.health) @ "/" @ getCommaNumber(%col.maxhealth));
			}
		}
		else
			%obj.client.centerPrint("<font:Impact:24><color:ff0000>This brick is marked as invincible.",1);
	}
}

function miningSpawnBot(%spawnBrick,%position,%which)
{
	switch(%which)
	{
		case 1:
			%player = new AIPlayer()
			{
				dataBlock = ZombieHoleBot;
				path = "";
				spawnBrick = %spawnBrick;
				position = %position;
				Name = ZombieHoleBot.hName;
				hType = ZombieHoleBot.hType;
				hSearchRadius = ZombieHoleBot.hSearchRadius;
				hSearch = ZombieHoleBot.hSearch;
				hSight = ZombieHoleBot.hSight;
				hWander = ZombieHoleBot.hWander;
				hGridWander = ZombieHoleBot.hGridWander;
				hReturnToSpawn = ZombieHoleBot.hReturnToSpawn;
				hSpawnDist = ZombieHoleBot.hSpawnDist;
				hMelee = ZombieHoleBot.hMelee;
				hAttackDamage = ZombieHoleBot.hAttackDamage;
				hSpazJump = ZombieHoleBot.hSpazJump;
				hSearchFOV = ZombieHoleBot.hSearchFOV;
				hFOVRadius = ZombieHoleBot.hFOVRadius;
				hTooCloseRange = ZombieHoleBot.hTooCloseRange;
				hAvoidCloseRange = ZombieHoleBot.hAvoidCloseRange;
				hShoot = ZombieHoleBot.hShoot;
				hMaxShootRange = ZombieHoleBot.hMaxShootRange;
				hStrafe = ZombieHoleBot.hStrafe;
				hAlertOtherBots = ZombieHoleBot.hAlertOtherBots;
				hIdleAnimation = ZombieHoleBot.hIdleAnimation;
				hSpasticLook = ZombieHoleBot.hSpasticLook;
				hAvoidObstacles = ZombieHoleBot.hAvoidObstacles;
				hIdleLookAtOthers = ZombieHoleBot.hIdleLookAtOthers;
				hIdleSpam = ZombieHoleBot.hIdleSpam;
				hAFKOmeter = ZombieHoleBot.hAFKOmeter + getRandom( 0, 2 );
				hHearing = ZombieHoleBot.hHearing;
				hIdle = ZombieHoleBot.hIdle;
				hSmoothWander = ZombieHoleBot.hSmoothWander;
				hEmote = ZombieHoleBot.hEmote;
				hSuperStacker = ZombieHoleBot.hSuperStacker;
				hNeutralAttackChance = ZombieHoleBot.hNeutralAttackChance;
				hFOVRange = ZombieHoleBot.hFOVRange;
				hMoveSlowdown = ZombieHoleBot.hMoveSlowdown;
				hMaxMoveSpeed = 1.0;
				hActivateDirection = ZombieHoleBot.hActivateDirection;
				isHoleBot = 1;
			};
		case 2:
			%player = new AIPlayer()
			{
				dataBlock = RadZombieHoleBot;
				path = "";
				spawnBrick = %spawnBrick;
				position = %position;
				Name = RadZombieHoleBot.hName;
				hType = RadZombieHoleBot.hType;
				hSearchRadius = RadZombieHoleBot.hSearchRadius;
				hSearch = RadZombieHoleBot.hSearch;
				hSight = RadZombieHoleBot.hSight;
				hWander = RadZombieHoleBot.hWander;
				hGridWander = RadZombieHoleBot.hGridWander;
				hReturnToSpawn = RadZombieHoleBot.hReturnToSpawn;
				hSpawnDist = RadZombieHoleBot.hSpawnDist;
				hMelee = RadZombieHoleBot.hMelee;
				hAttackDamage = RadZombieHoleBot.hAttackDamage;
				hSpazJump = RadZombieHoleBot.hSpazJump;
				hSearchFOV = RadZombieHoleBot.hSearchFOV;
				hFOVRadius = RadZombieHoleBot.hFOVRadius;
				hTooCloseRange = RadZombieHoleBot.hTooCloseRange;
				hAvoidCloseRange = RadZombieHoleBot.hAvoidCloseRange;
				hShoot = RadZombieHoleBot.hShoot;
				hMaxShootRange = RadZombieHoleBot.hMaxShootRange;
				hStrafe = RadZombieHoleBot.hStrafe;
				hAlertOtherBots = RadZombieHoleBot.hAlertOtherBots;
				hIdleAnimation = RadZombieHoleBot.hIdleAnimation;
				hSpasticLook = RadZombieHoleBot.hSpasticLook;
				hAvoidObstacles = RadZombieHoleBot.hAvoidObstacles;
				hIdleLookAtOthers = RadZombieHoleBot.hIdleLookAtOthers;
				hIdleSpam = RadZombieHoleBot.hIdleSpam;
				hAFKOmeter = RadZombieHoleBot.hAFKOmeter + getRandom( 0, 2 );
				hHearing = RadZombieHoleBot.hHearing;
				hIdle = RadZombieHoleBot.hIdle;
				hSmoothWander = RadZombieHoleBot.hSmoothWander;
				hEmote = RadZombieHoleBot.hEmote;
				hSuperStacker = RadZombieHoleBot.hSuperStacker;
				hNeutralAttackChance = RadZombieHoleBot.hNeutralAttackChance;
				hFOVRange = RadZombieHoleBot.hFOVRange;
				hMoveSlowdown = RadZombieHoleBot.hMoveSlowdown;
				hMaxMoveSpeed = 1.5;
				hActivateDirection = RadZombieHoleBot.hActivateDirection;
				isHoleBot = 1;
			};
		}
}

function serverCmdUpgradePick(%client,%times)
{
	if(strStr(%times,".") != -1)
		return;
	if(!%times)
		%times = 1;

	if(%client.cost <= %client.cash)
		%client.play2D(levelUpSound);
	else
		%client.play2D(miningErrorSound);

	for(%i=0;%i<%times;%i++)
	{
		if(%client.cost > %client.cash)
		{
			%client.centerPrint("<font:Impact:24>\c6You do not have enough to upgrade your pickaxe.",2);
			break;
		}
		else
		{
			//%client.cash -= %client.cost;
			//%client.cost += %client.level*1+(getRandom(1,800)/7*(%client.level/5));
			//%client.cost = mCeil(%client.cost);
			//%client.level++;
			%client.cash = math_Subtract(%client.cash,%client.cost);
			%client.cost = math_Add(%client.cost,mCeil(%client.level*1+(getRandom(1,800)/7*(%client.level/5))));
			//%client.cost = mCeil(%client.cost);
			%client.level++;
			%client.score = %client.level;
			%client.centerPrint("<font:Impact:24>\c6Your pickaxe is now level" SPC %client.level @ ".",2);

			sendGUICommand(%client,"cash");
			sendGUICommand(%client,"level");
		}
	}
}

function serverCmdUpgradeMaxHealth(%client)
{
	%cost = ((%client.maxhealth-75)/25) * 1500;

	if(%cost > %client.cash)
	{
		%client.centerPrint("<font:Impact:24>\c6You do not have $" @ getCommaNumber(%cost) SPC "to upgrade your health to" SPC getCommaNumber(%client.maxHealth + 25) @ ".",3);
		%client.play2D(miningErrorSound);
		return;
	}
	else
	{
		//%client.cash -= %cost;
		%client.cash = math_Subtract(%client.cash,%cost);
		%client.maxHealth += 25;
		decreasePlayerHealth(%client,-25);

		sendGUICommand(%client,"health");
		sendGUICommand(%client,"cash");

		%client.centerPrint("<font:Impact:24>\c6You upgraded your maximum health to" SPC getCommaNumber(%client.maxHealth) SPC "for $" @ getCommaNumber(%cost),3);
		%client.play2D(buyItemSound);
	}
}


function serverCmdUpgradeDynamite(%client)
{
	if(!%client.dynamiteLevel)
		%client.dynamiteLevel = 1;

	if(%client.dynamiteLevel < 20)
	{
		%cost = %client.dynamiteLevel * 700;

		if(%cost > %client.cash)
		{
			%client.centerPrint("\c6<font:Impact:24>\c6You do not have $" @ getCommaNumber(%cost) SPC "to upgrade your dynamite level.",2);
			%client.play2D(miningErrorSound);
			return;
		}
		else
		{
			//%client.cash -= %cost;
			%client.cash = math_Subtract(%client.cash,%cost);
			%client.dynamiteLevel++;
			sendGUICommand(%client,"cash");
			sendGUICommand(%client,"dynamite");
			%client.centerPrint("<font:Impact:24>\c6Your dynamite is now level" SPC %client.dynamiteLevel @ ", and dynamite now costs $" @ getCommaNumber(%client.dynamiteLevel * 500) @ ".",2);
			%client.play2D(buyItemSound);
		}
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6Your dynamite level is already maxxed out at level 20!",2);
		%client.play2D(miningErrorSound);
	}
}

function dynamiteSpamPrevent(%client)
{
	%client.canBuyDynamite = 1;
	messageClient(%client,'',"\c6You can buy dynamite again.");
}

function serverCmdBuyDynamite(%client)
{

	if(!%client.dynamiteLevel)
		%client.dynamiteLevel = 1;

	if(!%client.canBuyDynamite)
	{
		%client.centerPrint("<font:Impact:24>\c6You must wait 90 seconds before buying another stick of dynamite.",3);
		%client.play2D(MiningErrorSound);
		return;
	}

	if(!%client.dynamiteEnabled)
	{
		%cost = %client.dynamiteLevel * 500;

		if(%cost > %client.cash)
		{
			%client.centerPrint("<font:Impact:24>\c6You do not have $" @ getCommaNumber(%cost) SPC "to buy dynamite.",2);
			%client.play2D(miningErrorSound);
			return;
		}
		else
		{
			%client.dynamiteEnabled = 1;

			%client.player.tool[4] = dynamiteItem.getID();
			messageClient(%client,'MsgItemPickup','',4,dynamiteItem.getID());

			//%client.cash -= %cost;
			%client.cash = math_Subtract(%client.cash,%cost);

			%client.centerPrint("<font:Impact:24>\c6You bought dynamite for $" @ getCommaNumber(%cost) @ ".",2);
			sendGUICommand(%client,"cash");
			sendGUICommand(%client,"dynamite");
			%client.play2D(buyItemSound);
		}
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6You already bought dynamite! Use it first!",2);
		%client.play2D(miningErrorSound);
	}
}



function serverCmdReset(%client,%sure)
{
	if(%sure !$= "yes")
	{
		%client.centerPrint("<font:Impact:24>\c6If you're sure you want to reset, chat /reset yes.",2);
		%client.play2D(miningErrorSound);
		return;
	}
	if(%sure $= "yes")
	{
		miningLoad(%client,"reset");
		%client.centerPrint("<font:Impact:24>\c6Your stats have been reset.",2);
		sendGUICommand(%client,"cash");
		sendGUICommand(%client,"dynamite");
		sendGUICommand(%client,"level");
		sendGUICommand(%client,"dirt");
		sendGUICommand(%client,"radsuit");
		sendGUICommand(%client,"heatsuit");
	}
}

function serverCmdBuyHeatSuit(%client,%amount)
{
	if(strStr(%amount,".") != -1)
		return;
	if(!%amount || %amount < 0)
		%amount = 1;

	%cost = %amount * 40;

	if(%cost > %client.cash)
	{
		%client.centerPrint("<font:Impact:24>\c6You do not have $" @ getCommaNumber(%cost) SPC "to buy" SPC getCommaNumber(%amount) SPC "heatsuit(s).",3);
		%client.play2D(miningErrorSound);
		return;
	}
	else
	{
		%client.play2D(buyItemSound);
		//%client.cash -= %cost;
		%client.cash = math_Subtract(%client.cash,%cost);
		%client.heatsuits += %amount;
		%client.centerPrint("<font:Impact:24>\c6You bought" SPC getCommaNumber(%amount) SPC "heatsuit(s) for $" @ getCommaNumber(%cost) @ ".",3);
		sendGUICommand(%client,"cash");
		sendGUICommand(%client,"heatsuit");
	}
}

function serverCmdBuyRadSuit(%client,%amount)
{
	if(strStr(%amount,".") != -1)
		return;
	if(!%amount || %amount < 0)
		%amount = 1;

	%cost = %amount * 200;

	if(%cost > %client.cash)
	{
		%client.centerPrint("<font:Impact:24>\c6You do not have $" @ getCommaNumber(%cost) SPC "to buy" SPC getCommaNumber(%amount) SPC "radsuit(s).",3);
		%client.play2D(miningErrorSound);
		return;
	}
	else
	{
		%client.play2D(buyItemSound);
		//%client.cash -= %cost;
		%client.cash = math_Subtract(%client.cash,%cost);
		%client.radsuits += %amount;
		%client.centerPrint("<font:Impact:24>\c6You bought" SPC getCommaNumber(%amount) SPC "radsuit(s) for $" @ getCommaNumber(%cost) @ ".",3);
		sendGUICommand(%client,"cash");
		sendGUICommand(%client,"radsuit");
	}
}

function serverCmdBuyWaterSpray(%client)
{
	if(!%client.waterspray)
	{
		if(%client.cash < 400)
		{
			%client.centerPrint("<font:Impact:24>\c6You do not have $400 to buy the water spray.",3);
			%client.play2D(miningErrorSound);
			return;
		}
		else
		{
			%client.play2D(buyItemSound);
			//%client.cash -= 400;
			%client.cash = math_Subtract(%client.cash,400);
			%client.waterspray = 1;
			%client.centerPrint("<font:Impact:24>\c6You bought the water spray for $400.",2);

			%client.player.tool[1] = WaterSprayItem.getID();
			messageClient(%client,'MsgItemPickup','',1,WaterSprayItem.getID());
			sendGUICommand(%client,"cash");
		}
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6You already own the water spray!",2);
		%client.play2D(miningErrorSound);
	}
}

function serverCmdBuyDirtPlacer(%client)
{
	if(!%client.dirtplacer)
	{
		if(%client.cash < 400)
		{
			%client.centerPrint("<font:Impact:24>\c6You do not have $400 to buy the dirt placer.",3);
			%client.play2D(miningErrorSound);
			return;
		}
		else
		{
			%client.play2D(buyItemSound);
			//%client.cash -= 400;
			%client.cash = math_Subtract(%client.cash,400);
			%client.dirtplacer = 1;
			%client.centerPrint("<font:Impact:24>\c6You bought the dirt placer for $400.",2);

			%client.player.tool[2] = DirtPlacerItem.getID();
			messageClient(%client,'MsgItemPickup','',2,DirtPlacerItem.getID());
			sendGUICommand(%client,"cash");
		}
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6You already own the dirt placer!",2);
		%client.play2D(miningErrorSound);
	}
}

function serverCmdBuyLantern(%client)
{
	if(!%client.lantern)
	{
		if(%client.cash < 500)
		{
			%client.centerPrint("<font:Impact:24>\c6You do not have $500 to buy a lantern.",3);
			%client.play2D(miningErrorSound);
			return;
		}
		else
		{
			%client.play2D(buyItemSound);
			//%client.cash -= 500;
			%client.cash = math_Subtract(%client.cash,500);
			%client.lantern = 1;
			%client.centerPrint("<font:Impact:24>\c6You bought a lantern for $500.",2);

			%client.player.tool[3] = LanternItem.getID();
			messageClient(%client,'MsgItemPickup','',3,LanternItem.getID());
			sendGUICommand(%client,"cash");
		}
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6You already own a lantern!",2);
		%client.play2D(miningErrorSound);
	}
}

function serverCmdBuyBuildAreaMarker(%client)
{
	if(!%client.buildPlacer)
	{
		if(%client.cash < 7500)
		{
			%client.centerPrint("<font:Impact:24>\c6You do not have $7,500 to buy a build area marker.",3);
			%client.play2D(miningErrorSound);
			return;
		}
		else
		{
			%client.play2D(buyItemSound);
			//%client.cash -= 7500;
			%client.cash = math_Subtract(%client.cash,7500);
			%client.buildPlacer = 1;
			%client.centerPrint("<font:Impact:24>\c6You bought a build area marker for $7,500.",2);

			%client.player.tool[6] = BuildAreaPlacerItem.getID();
			messageClient(%client,'MsgItemPickup','',6,BuildAreaPlacerItem.getID());
			sendGUICommand(%client,"cash");
		}
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6You already own a build area marker!",2);
		%client.play2D(miningErrorSound);
	}
}

function serverCmdBuySword(%client)
{
	if(!%client.sword)
	{
		if(%client.cash < 750)
		{
			%client.centerPrint("<font:Impact:24>\c6You do not have $750 to buy the sword.",3);
			%client.play2D(miningErrorSound);
			return;
		}
		else
		{
			%client.play2D(buyItemSound);
			//%client.cash -= 750;
			%client.cash = math_Subtract(%client.cash,750);
			%client.sword = 1;
			%client.centerPrint("<font:Impact:24>\c6You bought the sword for $750.",2);

			%client.player.tool[5] = SwordItem.getID();
			messageClient(%client,'MsgItemPickup','',5,SwordItem.getID());
			sendGUICommand(%client,"cash");
		}
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6You already own the sword!",2);
		%client.play2D(miningErrorSound);
	}
}

function miningLoop()
{
	cancel($MiningLoop);

	for(%i=0;%i<clientGroup.getCount();%i++)
	{
		%client = clientGroup.getObject(%i);

		//%client.cash = mFloor(%client.cash);
		//%client.dirt = mFloor(%client.dirt);

		if(isObject(%client.player))
		{
			%cash = %client.cash;
			%dirt = %client.dirt;
			%level = %client.level;
			%cost = %client.cost;
			%radsuits = %client.radsuits;
			%heatsuits = %client.heatsuits;
			%points = %client.points;
			%LOC = mFloor(getWord(%client.player.position,0)) SPC mFloor(getWord(%client.player.position,1)) SPC mFloor(getWord(%client.player.position,2));
			if(!%client.GUI)
				//%client.bottomPrint("<font:Impact:19>\c2$" @ %cash @ " \c7|| \c5Lvl " @ %level @ " \c6[$" @ %cost @ "] \c7|| <color:AA6622>" @ %dirt @ " Dirt<just:right>\c6" @ %client.player.health @ " Health\c7 || \c0" @ %heatsuits SPC "Heatsuits\c7 || \c3" @ %radsuits SPC "Radsuits\c7 || \c4" @ %LOC @ " \c7||",2);
				%client.bottomPrint("<font:Impact:19>\c2$" @ getCommaNumber(%cash,1) @ " \c7|| \c5Lvl " @ %level @ " \c6[$" @ getCommaNumber(%cost) @ "] \c7|| <color:AA6622>" @ getCommaNumber(%dirt) @ " Dirt<just:right>\c6" @ getCommaNumber(%points) SPC "points<br><just:left>\c6" @ getCommaNumber(%client.player.health) @ " Health\c7 || \c0" @ getCommaNumber(%heatsuits) SPC "Heatsuits\c7 || \c3" @ getCommaNumber(%radsuits) SPC "Radsuits\c7 || \c4" @ %LOC,2);
			else
			{
				sendGUICommand(%client,"location");
				sendGUICommand(%client,"brickcount");
				sendGUICommand(%client,"health");
			}
			if(getWord(%client.player.getPosition(),2) <= 16000 && %client.heatsuits <= 0)
			{
				decreasePlayerHealth(%client,2);
				%client.centerPrint("<font:Impact:24>\c6You need to buy a heatsuit to withstand the heat down here!",3);
			}
			if(getWord(%client.player.getPosition(),2) <= 10000 && %client.radsuits <= 0)
			{
				decreasePlayerHealth(%client,4);
				%client.centerPrint("<font:Impact:24>\c6You need to buy a radsuit to withstand the radiation down here!",3);
			}
		}
	}
	$MiningLoop = schedule(1500,0,MiningLoop);
}

function serverCmdReceivedHandshake(%client,%update)
{
	%client.GUI = 1;
	echo("SERVER: Got notification of presence, enabling server-sided GUI code for" SPC %client.name);
}

function serverCmdOreSettings(%client)
{
	if(%client.isSuperAdmin)
	{
		if(%client.GUI)
			commandToClient(%client,'OpenOreSettings');
		else
		{
			%client.centerPrint("<font:Impact:24>\c6You need to have the GUI in order to customize the ore database!",2);
			%client.play2D(miningErrorSound);
		}
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6Only the host and super admins can use this command.",2);
		%client.play2D(miningErrorSound);
	}
}

function serverCmdShop(%client)
{
	if(%client.GUI)
	{
		commandToClient(%client,'OpenShop');
		serverCmdSendShopButtonVars(%client);
		serverCmdSendShopOres(%client);
	}
}

function doRandomAmbience()
{
	cancel($Mining::AmbienceLoop);
	serverPlay2D(ambience_ @ getRandom(1,8));
	$Mining::AmbienceLoop = schedule(getRandom(30000,120000),0,doRandomAmbience);
}
doRandomAmbience();

function serverCmdReceiveShopRequest(%client,%which,%amount)
{
	if(%client.GUI)
	{
		echo("SERVER: Received a" SPC %which SPC "shop request from" SPC %client @ ", sending back the price...");
		switch$(%which)
		{
			case "pickaxe":
				%before = %client.level;
				serverCmdUpgradePick(%client,1);
				%after = %client.level;

				if(%before == %after)
				{
					echo("SERVER: Transaction was a failure.");
					commandToClient(%client,'Shop_upgradePickaxe',%client.level,"fail",math_Subtract(%client.cost,%client.cash));
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_upgradePickaxe',%client.level,"good");
				}

			case "heatsuit":
				%before = %client.heatsuits;
				serverCmdBuyHeatSuit(%client,%amount);
				%after = %client.heatsuits;

				if(%before == %after)
				{
					echo("SERVER: Transaction was a failure.");
					commandToClient(%client,'Shop_buyHeatsuit',%amount,"fail",math_Subtract(math_Multiply(%amount,40),%client.cash));
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_buyHeatsuit',%after,"good");
				}

			case "radsuit":
				%before = %client.radsuits;
				serverCmdBuyRadSuit(%client,%amount);
				%after = %client.radsuits;

				if(%before == %after)
				{
					echo("SERVER: Transaction was a failure.");
					commandToClient(%client,'Shop_buyRadsuit',%amount,"fail",math_Subtract(math_Multiply(%amount,200),%client.cash));
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_buyRadsuit',%after,"good");
				}

			case "waterspray":
				%before = %client.waterspray;
				serverCmdBuyWaterSpray(%client);
				%after = %client.waterspray;

				if(%before == %after)
				{
					if(%before != 1)
					{
						echo("SERVER: Transaction was a failure.");
						commandToClient(%client,'Shop_buyWaterspray',"fail",math_Subtract(400,%client.cash));
					}
					else
					{
						echo("SERVER: Client already owns this.");
						commandToClient(%client,'Shop_buyWaterSpray',"owned");
					}
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_buyWaterspray',"good");
				}


			case "dirtplacer":
				%before = %client.dirtplacer;
				serverCmdBuyDirtPlacer(%client);
				%after = %client.dirtplacer;

				if(%before == %after)
				{
					if(%before != 1)
					{
						echo("SERVER: Transaction was a failure.");
						commandToClient(%client,'Shop_buyDirtPlacer',"fail",math_Subtract(400,%client.cash));
					}
					else
					{
						echo("SERVER: Client already owns this.");
						commandToClient(%client,'Shop_buyDirtPlacer',"owned");
					}
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_buyDirtPlacer',"good");
				}

			case "lantern":
				%before = %client.lantern;
				serverCmdBuyLantern(%client);
				%after = %client.lantern;

				if(%before == %after)
				{
					if(%before != 1)
					{
						echo("SERVER: Transaction was a failure.");
						commandToClient(%client,'Shop_buyLantern',"fail",math_Subtract(500,%client.cash));
					}
					else
					{
						echo("SERVER: Client already owns this.");
						commandToClient(%client,'Shop_buyLantern',"owned");
					}
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_buyLantern',"good");
				}

			case "heal":
				%before = %client.player.health;
				serverCmdHeal(%client,%amount);
				%after = %client.player.health;

				if(%before == %after)
				{
					echo("SERVER: Transaction was a failure.");
					commandToClient(%client,'Shop_Heal',%amount,0,"fail");
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_Heal',%client.player.health,%client.maxHealth,"good");
				}

			case "upgradedynamite":
				%before = %client.dynamiteLevel;
				serverCmdUpgradedynamite(%client);
				%after = %client.dynamiteLevel;

				if(%before == %after)
				{
					echo("SERVER: Transaction was a failure.");
					commandToClient(%client,'Shop_upgradedynamite',%client.dynamiteLevel,"fail",%client.dynamiteLevel * 700);
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_upgradedynamite',%client.dynamiteLevel,"good");
				}

			case "buydynamite":
				//only reason %client.dynamiteEnabled exists at all
				%before = %client.dynamiteEnabled;
				serverCmdBuydynamite(%client);
				%after = %client.dynamiteEnabled;

				if(%before == %after)
				{
					if(%before != 1)
					{
						echo("SERVER: Transaction was a failure.");
						commandToClient(%client,'Shop_buydynamite',"fail",%client.dynamiteLevel * 500);
					}
					else
					{
						echo("SERVER: Client already owns this.");
						commandToClient(%client,'Shop_buydynamite',"owned");
					}
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_buydynamite',"good");
				}

			case "superpickaxe":
				%before = %client.pickaxe;
				serverCmdBuySuperPickaxe(%client);
				%after = %client.pickaxe;

				if(%before == %after)
				{
					if(%before != 1)
					{
						echo("SERVER: Transaction was a failure.");
						commandToClient(%client,'Shop_buySuperPickaxe',"fail",math_Subtract(250000,%client.cash));
					}
					else
					{
						echo("SERVER: Client already owns this.");
						commandToClient(%client,'Shop_buySuperPickaxe',"owned");
					}
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_buySuperPickaxe',"good");
				}

			case "sword":
				%before = %client.sword;
				serverCmdBuySword(%client);
				%after = %client.sword;

				if(%before == %after)
				{
					if(%before != 1)
					{
						echo("SERVER: Transaction was a failure.");
						commandToClient(%client,'Shop_buySword',"fail",math_Subtract(750,%client.cash));
					}
					else
					{
						echo("SERVER: Client already owns this.");
						commandToClient(%client,'Shop_buySword',"owned");
					}
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_buySword',"good");
				}

			case "ultimatepickaxe":
				%before = %client.pickaxe;
				serverCmdBuyUltimatePickaxe(%client);
				%after = %client.pickaxe;

				if(%before == %after)
				{
					if(%before <= 1)
					{
						echo("SERVER: Transaction was a failure.");
						commandToClient(%client,'Shop_buyUltimatePickaxe',"fail",math_Subtract(1750000,%client.cash));
					}
					else
					{
						echo("SERVER: Client already owns this.");
						commandToClient(%client,'Shop_buyUltimatePickaxe',"owned");
					}
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_buyUltimatePickaxe',"good");
				}

			case "buildplacer":
				%before = %client.buildPlacer;
				serverCmdBuyBuildAreaMarker(%client);
				%after = %client.buildPlacer;

				if(%before == %after)
				{
					if(%before != 1)
					{
						echo("SERVER: Transaction was a failure.");
						commandToClient(%client,'Shop_buyBuildPlacer',"fail",math_Subtract(7500,%client.cash));
					}
					else
					{
						echo("SERVER: Client already owns this.");
						commandToClient(%client,'Shop_buyBuildPlacer',"owned");
					}
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_buyBuildPlacer',"good");
				}

			case "maxhealth":
				%before = %client.maxhealth;
				serverCmdUpgradeMaxHealth(%client);
				%after = %client.maxHealth;

				if(%before == %after)
				{
					echo("SERVER: Transaction was a failure.");
					commandToClient(%client,'Shop_upgradeMaxHealth',%client.maxHealth,"fail",math_Subtract(((%client.maxhealth-75)/25) * 1500,%client.cash));
				}
				else
				{
					echo("SERVER: Transaction was a success.");
					commandToClient(%client,'Shop_upgradeMaxHealth',%client.maxHealth,"good");
				}
		}
	}
}

function serverCmdSendShopButtonVars(%client)
{
	if(%client.GUI)
	{
		echo("SERVER: Got button vars request from" SPC %client SPC "sending back what has been bought...");
		commandToClient(%client,'ReceiveShopButtonVars',%client.waterspray,%client.dirtplacer,%client.maxhealth - %client.player.health,%client.lantern,%client.dynamiteLevel,%client.pickaxe,%client.sword,%client.buildPlacer,%client.maxhealth);
	}
}

function serverCmdHelp(%client,%a)
{
	if(%a $= "")
	{
		messageClient(%client,'',"\c2/help \c6-- This.");
		messageClient(%client,'',"\c2/upgradePick \c3[amount or blank] \c6-- Upgrade your pickaxe.");
		messageClient(%client,'',"\c2/buyHeatsuit \c3[amount] \c6-- Buy some heatsuits so you can be OK with lava. \c3[$40 for 1]");
		messageClient(%client,'',"\c2/buyRadsuit \c3[amount] \c6-- Buy some radsuits so you can also be OK with radiation. \c3[$200 for 1]");
		messageClient(%client,'',"\c2/buyWaterSpray \c6-- Buy some water spray to unleash your hatred of lava. \c3[$400]");
		messageClient(%client,'',"\c2/buyDirtPlacer \c6-- Buy a dirt placer, I guess. \c3[$400]");
		messageClient(%client,'',"\c2/buyLantern \c6-- Buy a lantern, I guess, again. \c3[$500]");
		messageClient(%client,'',"\c2/reset \c6-- Erase your game and begin anew.");
		messageClient(%client,'',"\c2/heal \c3[amount or blank] \c6-- Heal yourself. \c3[5 dirt for 1]");
		messageClient(%client,'',"\c2/upgradeDynamite \c6-- Upgrades your dynamite, maxes out at level 20. \c3[$700 * level]");
		messageClient(%client,'',"\c2/buyDynamite \c6-- (For now) Enabled dynamite on your pickaxe. \c3[$500 * level]");
		messageClient(%client,'',"\c2/buySuperPickaxe \c6-- Buy a much faster, red pickaxe. \c3[$250,000; must be at least Lv. 50]");
		messageClient(%client,'',"\c2/buyUltimatePickaxe \c6-- Buy a sweet, explosive, long-range, sonicspeed green pickaxe, with flares. \c3[$1,750,000; must be at least Lv. 125]");
		messageClient(%client,'',"\c2/toggleExplosions \c6-- Turn off explosions caused by the Ultimate Pickaxe, obviously only works if you have it.");
		messageClient(%client,'',"\c2/addCheckpoint \c6-- Add a checkpoint to your list of checkpoints.");
		messageClient(%client,'',"\c2/removeCheckpoint \c3[number in list] \c6-- Remove a checkpoint from your list of checkpoints.");
		messageClient(%client,'',"\c2/checkpoint \c3[number in list/list] \c6-- Go to a checkpoint in your list, or say \"list\" to see them all.");
		messageClient(%client,'',"\c2/teleport \c3[player] \c6-- Teleport to a friend you have trust with. \c3[varies (dirt)]");
		messageClient(%client,'',"\c2/listOres \c6-- See all ores on a server, and where you can find them.");
		messageClient(%client,'',"\c2/buySword \c6-- Buy a sword, because zombies. \c3[$750]");
		messageClient(%client,'',"\c2/donate \c3[player] [amount] [cash/dirt]\c6-- Donate to a player of your choosing.");
		messageClient(%client,'',"\c2/buyCustomOre \c6-- Buy your very own ore or 23. \c3[varies]");
		messageClient(%client,'',"\c2/miningTools \c6-- Switch to your mining tools.");
		messageClient(%client,'',"\c2/buildingTools \c6-- Switch to your building tools.");
		messageClient(%client,'',"\c2/buyBuildAreaMarker \c6-- Buy this if you want to build in a mining server and cross it off your bucket list. \c3[$7500]");
		messageClient(%client,'',"\c2/upgradeMaxHealth \c6-- Have health troubles? Attempt to get rid of them. \c3[varies]");
		messageClient(%client,'',"\c2/sellDirt \c3[amount] \c6-- Sell your dirt for some quick cash. \c2[4 for $1]");
		messageClient(%client,'',"\c2/toggleAutoLevel \c6-- Automatically upgrade your pickaxe level. Because you're all lazy.");
		messageClient(%client,'',"\c2/save \c6-- Save your game manually because you don't trust the server.");
		messageClient(%client,'',"\c5For GUI commands, see \c3/help GUI. \c2Use the Page Up and Page Down keys to navigate these messages.");
		//messageClient(%client,'',"\c6Brick price calculation: (length*width*height in plates)/10");
	}
	if(%a $= "GUI")
	{
		messageClient(%client,'',"\c2/shop \c6-- Brings up the Shop GUI.");
		messageClient(%client,'',"\c2/oreSettings \c5(Super Admins only) \c6-- Brings up the Ore DB Manager.");
	}
}

function serverCmdListOres(%client)
{
	for(%i=0;%i<Ores.getCount();%i++)
	{
		%ore = Ores.getObject(%i);
		messageClient(%client,'',"\c3" @ %ore.name SPC "\c6-- \c2$" @ %ore.value SPC " \c6-- \c3found between" SPC Block_getDirt("0 0" SPC %ore.minZ).name SPC "and" SPC Block_getDirt("0 0" SPC %ore.maxZ - 1).name);
	}
}

function serverCmdShop(%client)
{
	if(%client.GUI)
	{
		commandtoClient(%client,'openShop');
		serverCmdSendShopOres(%client);
	}
}

function serverCmdHeal(%client,%amount)
{
	if(strStr(%amount,".") != -1)
		return;
	if(%amount < 0)
		return;
	if(!%amount)
		%amount = %client.maxHealth - %client.player.health;

	if(%client.player.health == %client.maxHealth)
	{
		%client.centerPrint("<font:Impact:24>\c6You are already at full health!",2);
		%client.play2D(miningErrorSound);
		return;
	}
	if(%client.player.health + %amount > %client.maxHealth)
		while(%client.player.health + %amount > %client.maxHealth)
			%amount--;

	%cost = %amount * 5;

	if(%client.dirt < %cost)
	{
		%client.centerPrint("<font:Impact:24>\c6You do not have enough to heal by" SPC getCommaNumber(%amount) SPC "health.",3);
		%client.play2D(miningErrorSound);
		return;
	}
	decreasePlayerHealth(%client,%amount * -1);
	//%client.dirt -= %cost;
	%client.dirt = math_Subtract(%client.dirt,%cost);
	%client.centerPrint("<font:Impact:24>\c6You have been healed to" SPC getCommaNumber(%client.player.health) SPC "health for" SPC getCommaNumber(%cost) SPC "dirt.",3);
	%client.play2D(buyItemSound);
	sendGUICommand(%client,"dirt");

}

function serverCmdAddCheckpoint(%client)
{
	if(!isObject("MiningCheckpoints_" @ %client.bl_id))
		new SimSet("MiningCheckpoints_" @ %client.bl_id) { name = "MiningCheckpoints_" @ %client.bl_id; };

	%list = "MiningCheckpoints_" @ %client.bl_id;

	%position = %client.player.getPosition();
	%x = mFloor(getWord(%position,0)) + mFloor(getWord(%position,0)) % 2;
	%y = mFloor(getWord(%position,1)) + mFloor(getWord(%position,1)) % 2;
	%z = mFloor(getWord(%position,2)) + mFloor(getWord(%position,2)) % 2;
	%position = %x SPC %y SPC %z;

	%data = new ScriptObject(CheckpointData)
	{
		added = getDateTime();
		location = %position;
	};
	%list.add(%data);

	%client.centerPrint("<font:Impact:24>\c6You have added this spot to your checkpoint list.",2);
	%client.play2D(buyItemSound);

	//%client.checkpoint = %client.player.getPosition();
	//%client.centerPrint("<font:Impact:24>\c6Your checkpoint has been set. Use /teleport (at the cost of 125 dirt) any time to return to it.",2);
	//%client.play2D(buyItemSound);
}

function serverCmdRemoveCheckpoint(%client,%num)
{
	if(!isObject("MiningCheckpoints_" @ %client.bl_id))
		return;

	%list = "MiningCheckpoints_" @ %client.bl_id;
	%num--;

	if(%num > %list.getCount())
		return;

	%obj = %list.getObject(%num);

	%client.centerPrint("<font:Impact:24>\c6" @ %obj.location SPC "has been removed from your checkpoint list.",2);
	%client.play2D(buyItemSound);

	%obj.delete();
}

function serverCmdCheckpoint(%client,%num)
{
	if(%num $= "list" || %num $= "")
	{
		%list = "MiningCheckpoints_" @ %client.bl_id;

		for(%i=0;%i<%list.getCount();%i++)
		{
			%obj = %list.getObject(%i);
			%cost = mFloor(vectorDist(%obj.location,%client.player.getPosition())/100);
			messageClient(%client,'',"\c2" @ %i+1 @ ". \c3" @ %obj.location SPC "\c6(" @ %obj.added @ ")" SPC "<color:884400>[" @ %cost SPC "dirt]");
		}
	}
	else
	{
		%list = "MiningCheckpoints_" @ %client.bl_id;
		%num--;

		if(%num > %list.getCount())
			return;

		%position = %list.getObject(%num).location;
		%cost = mFloor(vectorDist(%client.player.getPosition(),%position)/100);

		if(%client.dirt >= %cost)
		{

			if(!$Mining::Block[%position])
			{
				placeMiningBlock(%position,1,1);

				for(%i=0;%i<2;%i++)
				{
					InitContainerRadiusSearch(%position,2,$TypeMasks::FXBrickObjectType);
					while((%targetObject = containerSearchNext()) !$= 0)
					{
						if(!%targetObject.invincible)
						{
							checkMiningBlock(%targetObject.getPosition(),1);
							%targetObject.delete();
						}
					}
				}
			}

			%client.player.setTransform(%position);
			%client.dirt = math_Subtract(%client.dirt,%cost);
			%client.play2D(buyItemSound);
			%client.centerPrint("<font:Impact:24>\c6You have teleported to" SPC %position SPC "for" SPC %cost SPC "dirt.",2);
			sendGUICommand(%client,"dirt");
		}
		else
		{
			%client.centerPrint("<font:Impact:24>\c6You do not have enough dirt to use your checkpoint.",2);
			%client.play2D(MiningErrorSound);
		}
	}
}

function serverCmdTeleport(%client,%target)
{
	%target = findClientByName(%target);

	%position = %target.player.getPosition();
	%cost = mFloor(vectorDist(%client.player.getPosition(),%position)/100);

	if(%client.dirt >= %cost)
	{
		if(%target !$= "")
		{

			if(isObject(%target.player))
			{
				if(getTrustLevel(%target,%client) != 0)
				{
					%client.player.setTransform(%target.player.getPosition());
					//%client.dirt -= 125;
					%client.dirt = math_Subtract(%client.dirt,%cost);
					%client.play2D(buyItemSound);
					%client.centerPrint("<font:Impact:24>\c6You have teleported to" SPC %target.name SPC "for" SPC %cost SPC "dirt.",2);
					sendGUICommand(%client,"dirt");
				}
				else
				{
					%client.centerPrint("<font:Impact:24>\c6" @ %target.name SPC "doesn't trust you enough to teleport to them.");
					%client.play2D(MiningErrorSound);
					return;
				}
			}
			else
			{
				%client.centerPrint("<font:Impact:24>\c6This player doesn't exist!");
				%client.play2D(MiningErrorSound);
				return;
			}
		}
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6You do not have 125 dirt to teleport to a player.",2);
		%client.play2D(MiningErrorSound);
	}
}

function servercmdBuySuperPickaxe(%client)
{
	if(%client.pickaxe < 1)
	{
		if(%client.level >= 50)
		{
			if(%client.cash >= 250000)
			{
				//%client.cash -= 250000;
				%client.cash = math_Subtract(%client.cash,250000);

				%client.pickaxe = 1;
				%client.player.tool[0] = MiningSuperPickaxeItem.getID();
				messageClient(%client,'MsgItemPickup','',0,MiningSuperPickaxeItem.getID());
				sendGUICommand(%client,"cash");

				%client.centerPrint("<font:Impact:24>\c6You bought the Super Pickaxe for $250,000!",2);
				messageAll('',"\c2" @ %client.name SPC "\c6just bought a Super Pickaxe!");
				%client.play2D(buyItemSound);
			}
			else
			{
				%client.centerPrint("<font:Impact:24>\c6You need at least $250,000 to buy the Super Pickaxe.",2);
				%client.play2D(MiningErrorSound);
			}
		}
		else
		{
			%client.centerPrint("<font:Impact:24>\c6You need to be at least level 60 before you can buy the Super Pickaxe.",2);
			%client.play2D(MiningErrorSound);
		}
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6You already own the Super Pickaxe!",2);
		%client.play2D(MiningErrorSound);
	}
}

function servercmdBuyUltimatePickaxe(%client)
{
	if(%client.pickaxe <= 1)
	{
		if(%client.level >= 125)
		{
			if(%client.cash >= 1750000)
			{
				//%client.cash -= 1750000;
				%client.cash = math_Subtract(%client.cash,1750000);

				%client.pickaxe = 2;
				%client.player.tool[0] = MiningUltimatePickaxeItem.getID();
				messageClient(%client,'MsgItemPickup','',0,MiningUltimatePickaxeItem.getID());
				sendGUICommand(%client,"cash");

				%client.centerPrint("<font:Impact:24>\c6You bought the Ultimate Pickaxe for $1,750,000!",2);
				messageAll('',"\c2" @ %client.name SPC "\c6just bought an ULTIMATE Pickaxe!");
				%client.play2D(buyItemSound);
			}
			else
			{
				%client.centerPrint("<font:Impact:24>\c6You need at least $1,750,000 to buy the Ultimate Pickaxe.",2);
				%client.play2D(MiningErrorSound);
			}
		}
		else
		{
			%client.centerPrint("<font:Impact:24>\c6You need to be at least level 125 before you can buy the Ultimate Pickaxe.",2);
			%client.play2D(MiningErrorSound);
		}
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6You already own the Ultimate Pickaxe!",2);
		%client.play2D(MiningErrorSound);
	}
}

function serverCmdSellDirt(%client,%amount)
{
	//if(strStr(%amount,".") != -1)
	//	return;
	if(!%amount)
	{
		%client.centerPrint("<font:Impact:24>\c6You didn't mention how much you want to sell!",2);
		%client.play2D(MiningErrorSound);
		return;
	}
	if(%client.dirt < %amount)
	{
		%client.centerPrint("<font:Impact:24>\c6You're trying to sell more dirt than you currently have.",2);
		%client.play2D(MiningErrorSound);
		return;
	}
	//while(%amount % 4 != 0)
	//	%amount--;

	%cost = %amount/4;
	//%client.cash += %cost;
	//%client.dirt -= %amount;
	%client.cash = math_Add(%client.cash,%cost);
	%client.dirt = math_Subtract(%client.dirt,%amount);
	%client.centerPrint("<font:Impact:24>\c6You sold" SPC getCommaNumber(%amount) SPC "dirt for $" @ %cost @ ".",2);
	%client.play2D(buyItemSound);
	sendGUICommand(%client,"dirt",%client.dirt);
	sendGUICommand(%client,"cash");
}

function serverCmdToggleExplosions(%client)
{
	if(%client.pickaxe != 2)
		return;
	
	if(%client.UTExplosion)
	{
		%client.centerPrint("<font:Impact:24>\c6Explosions from the Ultimate Pickaxe have been disabled.",3);
		%client.UTExplosion = 0;
		return;
	}
	else
	{
		%client.centerPrint("<font:Impact:24>\c6Explosions from the Ultimate Pickaxe have been enabled.",3);
		%client.UTExplosion = 1;
		return;
	}
}

function checkBrickCount()
{
	cancel($Mining::CheckBrickCount);
	$Mining::CheckBrickCount = schedule(15000,0,checkBrickCount);

	if(getBrickCount() >= 375000)
	{
		cancel($Mining::CheckBrickCount);
		noticeMessage("Brickcount is over 300,000, clearing all bricks in 3 minutes!");
		$MiningReset = schedule(180000,0,resetServer);
	}
}
checkBrickCount();

function resetServer()
{
	noticeMessage("Deleting" SPC getBrickCount() SPC "bricks...");
	serverCmdClearAllBricks(publicClient);
	resetServer_Step2();
}

function resetServer_Step2()
{
	cancel($cb);
	if(getBrickCount() != 0)
	{
		$cb = schedule(500,0,resetServer_Step2);
		noticeMessage(getBrickCount() SPC "bricks remain...");
	}
	else
	{
		cancel($MiningLoop);
		cancel($Mining::AutoSave);
		cancel($Mining::AmbienceLoop);
		deactivatePackage(MiningPackage);
		cancel($Mining::CheckBrickCount);
		$Mining::HasStarted = 0;
		$Mining::ExplosionsInProgress = 0;
		noticeMessage("Done, resetting global variables...");
		deleteVariables("$Mining::*");
		noticeMessage("Server reset.");
		checkBrickCount();
		noticeMessage("Done, running miningInit();");
		schedule(100,0,miningInit);
	}
}

function serverCmdSendOreList(%client)
{
	if(%client.isSuperAdmin)
	{
		if(%client.GUI)
		{
			echo("SERVER: Received ore DB request from" SPC %client);
			if(!isObject(Ores))
				echo("Ores database non-existant!");
			else
			{
				for(%i=0;%i<Ores.getCount();%i++)
				{
					%obj = Ores.getObject(%i);
					%name = %obj.name;
					%value = %obj.value;
					%health = %obj.health;
					%minZ = %obj.minZ;
					%maxZ = %obj.maxZ;
					%color = %obj.color;
					%minlevel = %obj.minlevel;
					%weight = %obj.weight;
					%colorfx = %obj.colorfx;
					%owner = %obj.owner;
					commandToClient(%client,'receiveOreRow',0,%name,%value,%health,%minZ,%maxZ,%color,%minlevel,%weight,%colorfx,%owner);
				}
				commandToClient(%client,'receiveOreRow',1);
			}
		}
		else
			%client.centerPrint("You need to use the GUI to use this command.",2);
	}
	else
		%client.centerPrint("Only the host can use this command.",2);
}

function serverCmdUpdateOres(%client)
{
	if(%client.isSuperAdmin)
		getOres();
}

function serverCmdStartNewOreDB(%client)
{
	if(%client.isSuperAdmin && %client.GUI)
	{
		$Mining::OreDBFile = new FileObject();
		$Mining::OreDBFile.openForWrite("config/server/EndlessMining/ores.txt");
	}

	if(isObject(Ores))
	{
		for(%i=0;%i<Ores.getCount();%i++)
			Ores.getObject(%i).delete();

		Ores.delete();
	}
	new SimSet(Ores) { name = "Ores"; };
}

function serverCmdReceiveOreDB(%client,%done,%name,%value,%health,%minZ,%maxZ,%color,%minlevel,%weight,%colorfx,%owner)
{
	if(%client.isSuperAdmin && %client.GUI)
	{
		if(%done)
		{
			$Mining::OreDBFile.close();
			$Mining::OreDBFile.delete();
			return echo("SERVER: Updated ore DB file.");
		}
		%ore = new ScriptObject(OreBlockData)
		{
			name = %name;
			value = %value;
			health = %health;
			minZ = %minZ;
			maxZ = %maxZ;
			color = %color;
			minlevel = %minlevel;
			weight = %weight;
			colorfx = %colorfx;
			owner = %owner;
			ID = Ores.getCount() + 1;
		};
		Ores.add(%ore);

		$Mining::OreDBFile.writeLine(%name TAB %value TAB %health TAB %minz TAB %maxz TAB %color TAB %minlevel TAB %weight TAB %colorfx TAB %owner);
	}
}

function serverCmdDonate(%client,%target,%amount,%type)
{
	if(strStr(%amount,".") != -1 && %type $= "dirt")
		return;
	if(%amount < 0)
		return;

	if(%type $= "")
	{
		%client.centerPrint("<font:Impact:24>\c6You didn't specify what item you want to donate!");
		%client.play2D(MiningErrorSound);
		return;
	}

	if(!isObject(findClientByName(%target)))
	{
		%client.centerPrint("<font:Impact:24>\c6This player doesn't exist!");
		%client.play2D(MiningErrorSound);
		return;
	}

	switch$(%type)
	{
		case "cash":
			if(%amount <= %client.cash)
			{
				%target = findClientByName(%target);

				//%client.cash -= %amount;
				//%target.cash += %amount;
				%client.cash = math_Subtract(%client.cash,%amount);
				%target.cash = math_Add(%target.cash,%amount);

				%target.centerPrint("<font:Impact:24>\c6You have been given $" @ getCommaNumber(%amount,1) SPC "by" SPC %client.name @ ".",2);
				%client.centerPrint("<font:Impact:24>\c6You have donated $" @ getCommaNumber(%amount,1) SPC "to" SPC %target.name @ ".",2);
				%client.play2D(buyItemSound);
				%target.play2D(buyItemSound);
				sendGUICommand(%client,"cash");
				sendGUICommand(%target,"cash");

			}
			else
			{
				%client.centerPrint("<font:Impact:24>\c6You're trying to donate more money than you have.");
				%client.play2D(MiningErrorSound);
			}

		case "dirt":
			if(%amount <= %client.dirt)
			{
				%target = findClientByName(%target);

				//%client.cash -= %amount;
				//%target.cash += %amount;
				%client.dirt = math_Subtract(%client.dirt,%amount);
				%target.dirt = math_Add(%target.dirt,%amount);

				%target.centerPrint("<font:Impact:24>\c6You have been given" SPC getCommaNumber(%amount) SPC "dirt by" SPC %client.name @ ".",2);
				%client.centerPrint("<font:Impact:24>\c6You have donated" SPC getCommaNumber(%amount) SPC "dirt to" SPC %target.name @ ".",2);
				%client.play2D(buyItemSound);
				%target.play2D(buyItemSound);
				sendGUICommand(%client,"dirt");
				sendGUICommand(%target,"dirt");

			}
			else
			{
				%client.centerPrint("<font:Impact:24>\c6You're trying to donate more dirt than you have.");
				%client.play2D(MiningErrorSound);
			}
		}
}


function serverCmdBuyCustomOre(%client)
{
	%factor = 1;

	for(%i=0;%i<Ores.getCount();%i++)
		if(Ores.getObject(%i).owner == %client.bl_id)
			%factor += 0.35;

	//%cost = 250000 * %factor;
	%cost = math_Multiply(250000,%factor);

	if(%client.cash < %cost)
	{
		%client.centerPrint("<font:Impact:24>\c6You do not have $" @ getCommaNumber(%cost) SPC "to buy a new ore.",3);
		%client.play2D(MiningErrorSound);
		return;
	}
	messageAll('',"\c2" @ %client.name SPC "\c6just bought a new ore!");

	%ore = new ScriptObject(OreBlockData)
	{
		name = %client.name @ "ium";
		value = getRandom(250,750);
		health = getRandom(250,750);
		minZ = 65000;
		maxZ = 999999;
		color = getRandom(0,63);
		minlevel = getRandom(10,50);
		weight = 7;
		colorfx = 0;
		owner = %client.bl_id;
		ID = Ores.getCount() + 1;
	};
	Ores.add(%ore);

	//%client.cash -= %cost;
	%client.cash = math_Subtract(%client.cash,%cost);
	sendGUICommand(%client,"cash");
	%client.centerPrint("<font:Impact:24>\c6You will find your ore above a depth of 65000.");
}

function serverCmdSendShopOres(%client)
{
	if(%client.GUI)
	{
		echo("SERVER: Got request for the custom ore list from" SPC %client);

		commandToClient(%client,'clearCustomOres');
		for(%i=0;%i<Ores.getCount();%i++)
		{
			%ore = Ores.getObject(%i);
			if(%ore.owner == %client.bl_id)
				commandToClient(%client,'receiveShopOre',0,%ore.name,%ore.value,%ore.health,%ore.color,%ore.minlevel,%ore.colorfx,%ore.ID);
		}
		commandToClient(%client,'receiveShopOre',1);
	}
}

function serverCmdUpdateCustomOre(%client,%name,%value,%health,%color,%ID,%colorfx)
{
	if(%client.GUI)
	{
		if(%name !$= "")
		{
			for(%i=0;%i<Ores.getCount();%i++)
			{
				%ore = Ores.getObject(%i);
				if(%client.bl_id == %ore.owner && %ore.ID == %ID)
				{
					%ore.name = %name;
					%ore.value = %value;
					%ore.health = %health;
					%ore.color = %color;
					%ore.colorfx = %colorfx;
				}
			}
			serverCmdSendShopOres(%client);
		}
	}
}


function miningAutoSave()
{
	cancel($Mining::AutoSave);
	for(%i=0;%i<clientGroup.getCount();%i++)
	{
		%client = clientGroup.getObject(%i);
		miningSave(%client);
		if($Mining_p::HighScore[1] < %client.points)
		{
			$Mining_p::HighScore[0] = %client.name;
			$Mining_p::HighScore[1] = %client.points;

			%file = new FileObject();
			%file.openForWrite("config/server/EndlessMining/DB/highscore");
			%file.writeLine($Mining_p::HighScore[0] TAB $Mining_p::HighScore[1]);
			%file.close();
			%file.delete();
		}
	}
	messageAll('',"\c6Your game has been saved.");
	messageAll('',"\c2" @ $Mining_p::HighScore[0] SPC "\c6currently has the high score, with \c3" @ getCommaNumber($Mining_p::HighScore[1]) SPC "points.");
	$Mining::AutoSave = schedule(300000,0,miningAutoSave);
}

function serverCmdSave(%client)
{
	miningSave(%client);
	messageClient(%client,'',"\c6Your game has been saved.");
}

function serverCmdBuildingTools(%client)
{
	%client.player.tool[0] = HammerItem.getID();
	messageClient(%client,'MsgItemPickup','',0,HammerItem.getID());
	%client.player.tool[1] = WrenchItem.getID();
	messageClient(%client,'MsgItemPickup','',1,WrenchItem.getID());
	%client.player.tool[2] = PrintGun.getID();
	messageClient(%client,'MsgItemPickup','',2,PrintGun.getID());
	if(%client.buildPlacer)
	{
		%client.player.tool[3] = BuildAreaPlacerItem.getID();
		messageClient(%client,'MsgItemPickup','',3,BuildAreaPlacerItem.getID());
	}
	%client.player.tool[4] = "";
	messageClient(%client,'MsgItemPickup','',4,0);
	%client.player.tool[5] = "";
	messageClient(%client,'MsgItemPickup','',5,0);
	%client.player.tool[6] = "";
	messageClient(%client,'MsgItemPickup','',6,0);
}

function serverCmdMiningTools(%client)
{
	if(%client.pickaxe == 2)
	{
		%client.player.tool[0] = MiningUltimatePickaxeItem.getID();
		messageClient(%client,'MsgItemPickup','',0,MiningUltimatePickaxeItem.getID());
	}
	if(%client.pickaxe == 1)
	{
		%client.player.tool[0] = MiningSuperPickaxeItem.getID();
		messageClient(%client,'MsgItemPickup','',0,MiningSuperPickaxeItem.getID());
	}
	if(!%client.pickaxe)
	{
		%client.player.tool[0] = MiningPickaxeItem.getID();
		messageClient(%client,'MsgItemPickup','',0,MiningPickaxeItem.getID());
	}

	if(%client.waterspray)
	{
		%client.player.tool[1] = WaterSprayItem.getID();
		messageClient(%client,'MsgItemPickup','',1,WaterSprayItem.getID());
	}
	else
	{
		%client.player.tool[5] = "";
		messageClient(%client,'MsgItemPickup','',1,0);
	}

	if(%client.dirtplacer)
	{
		%client.player.tool[2] = DirtPlacerItem.getID();
		messageClient(%client,'MsgItemPickup','',2,DirtPlacerItem.getID());
	}
	else
	{
		%client.player.tool[2] = "";
		messageClient(%client,'MsgItemPickup','',2,0);
	}

	if(%client.lantern)
	{
		%client.player.tool[3] = LanternItem.getID();
		messageClient(%client,'MsgItemPickup','',3,LanternItem.getID());
	}
	else
	{
		%client.player.tool[3] = "";
		messageClient(%client,'MsgItemPickup','',3,0);
	}

	if(%client.dynamiteEnabled)
	{
		%client.player.tool[4] = dynamiteItem.getID();
		messageClient(%client,'MsgItemPickup','',4,dynamiteItem.getID());
	}
	else
	{
		%client.player.tool[4] = "";
		messageClient(%client,'MsgItemPickup','',4,0);
	}

	if(%client.sword)
	{
		%client.player.tool[5] = SwordItem.getID();
		messageClient(%client,'MsgItemPickup','',5,SwordItem.getID());
	}
	else
	{
		%client.player.tool[5] = "";
		messageClient(%client,'MsgItemPickup','',5,0);
	}

	if(%client.buildPlacer)
	{
		%client.player.tool[6] = BuildAreaPlacerItem.getID();
		messageClient(%client,'MsgItemPickup','',6,BuildAreaPlacerItem.getID());
	}
	else
	{
		%client.player.tool[6] = "";
		messageClient(%client,'MsgItemPickup','',6,0);
	}
}

function decreasePlayerHealth(%client,%amount)
{
	%client.player.health -= %amount;
	%client.player.setDamageFlash(%amount/50 SPC "0 0");

	if(%client.player.health <= 0)
	{
		%client.player.health = 0;
		if(%client.player)
			%client.player.kill();
	}

	if(%client)
	{
		if(%client.GUI)
			sendGUICommand(%client,"health");
		else
			%client.centerPrint("<font:Impact:24>\c0Health:\c6" SPC getCommaNumber(%client.player.health),1);
	}
}

function doSunlight(%client)
{
	cancel($Mining::Sunlight);

	for(%i=0;%i<16;%i++)
	{
		schedule(40*%i,0,serverCmdEnvGui_setVar,publicClient,"DirectLightColor",%i/20 SPC %i/20 SPC %i/20);
		schedule(40*%i,0,serverCmdEnvGui_setVar,publicClient,"AmbientLightColor",%i/22 SPC %i/22 SPC %i/20);
		schedule(40*%i,0,serverCmdEnvGui_setVar,publicClient,"ShadowColor",%i/32 SPC %i/32 SPC %i/32);
	}
	//serverCmdEnvGui_setVar(publicClient,"DirectLightColor","0.8 0.8 0.8");
	//serverCmdEnvGui_setVar(publicClient,"AmbientLightColor","0.7 0.7 0.8");
	//serverCmdEnvGui_setVar(publicClient,"ShadowColor","0.5 0.5 0.5");

	messageAll('',"\c2" @ %client.name SPC "\c6said, \"Let there be light!\"");

	$Mining::Sunlight = schedule(30000,0,doDarkness);
}

function doDarkness()
{
	%j = 40*16;
	for(%i=0;%i<16;%i++)
	{
		schedule(%j - 40*%i,0,serverCmdEnvGui_setVar,publicClient,"DirectLightColor",%i/20 SPC %i/20 SPC %i/20);
		schedule(%j - 40*%i,0,serverCmdEnvGui_setVar,publicClient,"AmbientLightColor",%i/22 SPC %i/22 SPC %i/20);
		schedule(%j - 40*%i,0,serverCmdEnvGui_setVar,publicClient,"ShadowColor",%i/32 SPC %i/32 SPC %i/32);
	}
	//serverCmdEnvGui_setVar(publicClient,"DirectLightColor","0 0 0");
	//serverCmdEnvGui_setVar(publicClient,"AmbientLightColor","0 0 0");
	//serverCmdEnvGui_setVar(publicClient,"ShadowColor","0 0 0");

	messageAll('',"\c6Lights out!");
}

function sendGUICommand(%client,%which,%arg1,%arg2,%arg3,%arg4)
{
	//commandToClient(%client,'ReceiveHUD',"health",%client.player.health,%client.maxHealth);
	if(!isObject(%client))
		return;
	if(!%client.GUI)
		return 0;

	switch$(%which)
	{
		case "dirt":
			commandToClient(%client,'ReceiveHUD',%which,getCommaNumber(%client.dirt));
			return;
		case "radsuit":
			commandToClient(%client,'ReceiveHUD',%which,getCommaNumber(%client.radsuits));
			return;
		case "heatsuit":
			commandToClient(%client,'ReceiveHUD',%which,getCommaNumber(%client.heatsuits));
			return;
		case "cash":
			commandToClient(%client,'ReceiveHUD',%which,getCommaNumber(%client.cash,1));
			return;
		case "points":
			commandToClient(%client,'ReceiveHUD',%which,getCommaNumber(%client.points));
			return;
		case "level":
			commandToClient(%client,'ReceiveHUD',%which,%client.level,getCommaNumber(%client.cost));
			return;
		case "dynamite":
			commandToClient(%client,'ReceiveHUD',%which,%client.dynamiteLevel,getCommaNumber(%client.dynamiteLevel * 700));
			return;
		case "location":
			commandToClient(%client,'ReceiveHUD',%which,mFloor(getWord(%client.player.position,0)) SPC mFloor(getWord(%client.player.position,1)) SPC mFloor(getWord(%client.player.position,2)));
			return;
		case "brickcount":
			commandToClient(%client,'ReceiveHUD',%which,getCommaNumber(getBrickCount()),"375,000");
			return;
		case "health":
			commandToClient(%client,'ReceiveHUD',%which,getCommaNumber(%client.player.health),getCommaNumber(%client.maxHealth));
			return;
	}

	//in case it's foreign, or if i add more API variables that don't need to be default, it'll just send off the command.
	commandToClient(%client,'ReceiveHUD',%which,%arg1,%arg2,%arg3,%arg4);
}

function getWeightedCost(%obj,%col)
{
	%age = getAge(%col);
	if(%age <= 15000)
		return %col.value;
	if(%age >= 40000000)
		%age = 40000000;
	if(%col.radiated)
	{
		%cost = getSubStr(%age/75000000,0,9);
		%cost = math_Multiply(%col.value,%cost,2);
		//%cost = math_Subtract(%cost,%col.value * %obj.client.valueBuff);
		%cost = math_Subtract(%col.value * %obj.client.valueBuff,%cost);
	}
	else
	{
		%cost = getSubStr(%age/75000000,0,9);
		%cost = math_Multiply(%col.value,%cost,2);
		%cost = math_Add(%cost,%col.value * %obj.client.valueBuff);	
	}
	return %cost;
	//%obj.client.cash = math_Add(%obj.client.cash,%cost);
	//%obj.client.points = math_Add(%obj.client.points,%col.value);
}

function getAge(%col,%formatted)
{
	%age = getSimTime() - %col.created;

	if(!%formatted)
		return %age;
	else
		return getTimeString(mFloor(%age/1000));
}

package MiningPackage
{
	function GameConnection::spawnPlayer(%client)
	{
		parent::spawnPlayer(%client);
		commandToClient(%client,'createHUD');

		if(%client.pickaxe == 2)
		{
			%client.player.tool[0] = MiningUltimatePickaxeItem.getID();
			messageClient(%client,'MsgItemPickup','',0,MiningUltimatePickaxeItem.getID());
		}
		if(%client.pickaxe == 1)
		{
			%client.player.tool[0] = MiningSuperPickaxeItem.getID();
			messageClient(%client,'MsgItemPickup','',0,MiningSuperPickaxeItem.getID());
		}
		if(!%client.pickaxe)
		{
			%client.player.tool[0] = MiningPickaxeItem.getID();
			messageClient(%client,'MsgItemPickup','',0,MiningPickaxeItem.getID());
		}

		if(%client.waterspray)
		{
			%client.player.tool[1] = WaterSprayItem.getID();
			messageClient(%client,'MsgItemPickup','',1,WaterSprayItem.getID());
		}

		if(%client.dirtplacer)
		{
			%client.player.tool[2] = DirtPlacerItem.getID();
			messageClient(%client,'MsgItemPickup','',2,DirtPlacerItem.getID());
		}

		if(%client.lantern)
		{
			%client.player.tool[3] = LanternItem.getID();
			messageClient(%client,'MsgItemPickup','',3,LanternItem.getID());
		}

		if(%client.dynamiteEnabled)
		{
			%client.player.tool[4] = dynamiteItem.getID();
			messageClient(%client,'MsgItemPickup','',4,dynamiteItem.getID());
		}

		if(%client.sword)
		{
			%client.player.tool[5] = SwordItem.getID();
			messageClient(%client,'MsgItemPickup','',5,SwordItem.getID());
		}
		else
		{
			%client.player.tool[5] = "";
			messageClient(%client,'MsgItemPickup','',5,0);
		}

		if(%client.buildPlacer)
		{
			%client.player.tool[6] = BuildAreaPlacerItem.getID();
			messageClient(%client,'MsgItemPickup','',6,BuildAreaPlacerItem.getID());
		}
		else
		{
			%client.player.tool[6] = "";
			messageClient(%client,'MsgItemPickup','',6,0);
		}

		sendGUICommand(%client,"cash");
		sendGUICommand(%client,"level");
		sendGUICommand(%client,"dirt");
		sendGUICommand(%client,"radsuit");
		sendGUICommand(%client,"heatsuit");
		sendGUICommand(%client,"health");
		sendGUICommand(%client,"dynamite");
		sendGUICommand(%client,"brickcount");
		sendGUICommand(%client,"points");

		%client.score = %client.level;

		if(!%client.maxHealth)
			%client.maxHealth = 100;
		%client.player.health = %client.maxHealth;
	}

	function fxDtsBrick::onPlayerTouch(%this,%player)
	{
		if(%this.type $= "Lava" && %player.getClassName() !$= "AIPlayer" && %player.client.heatsuits <= 0)
			decreasePlayerHealth(%player.client,4);
	}

	function GameConnection::autoAdminCheck(%client)
	{
		parent::autoAdminCheck(%client);
		miningLoad(%client);

		%client.score = %client.level;
		%client.strengthBuff = 1;
		%client.valueBuff = 1;
		%client.canBuyDynamite = 1;

		commandToClient(%client,'ReceiveGUIHandshake');
		echo("SERVER: Sending GUI handshake...");

		messageClient(%client,'',"\c5Gamemode by TheBlackParrot (18701). \c6 Current version is \c2r" @ $MiningRev);
		messageClient(%client,'',"\c5Report bugs on the <a:forum.blockland.us/index.php?topic=235505>forum topic</a> or on the <a:bitbucket.org/TheBlackParrot/blockland-endless-mining/issues>git repo</a>.");
		messageClient(%client,'',"\c5The server's GUI API version is\c3" SPC $Mining::GUIVer @ ".");
	}

	function GameConnection::onClientLeaveGame(%client)
	{
		miningSave(%client);
		commandToClient(%client,'DestroyMiningGui');

		%file = new FileObject();
		%file.openForWrite("config/server/EndlessMining/ores.txt");

		for(%i=0;%i<Ores.getCount();%i++)
		{
			%ore = Ores.getObject(%i);
			%file.writeLine(%ore.name TAB %ore.value TAB %ore.health TAB %ore.minz TAB %ore.maxz TAB %ore.color TAB %ore.minlevel TAB %ore.weight TAB %ore.colorfx TAB %ore.owner);
		}

		%file.close();
		%file.delete();

		%list = "MiningCheckpoints_" @ %client.bl_id;
		if(isObject(%list))
		{
			for(%i=0;%i<%list.getCount();%i++)
				%list.getObject(%i).delete();
			%list.delete();
		}

		parent::onClientLeaveGame(%client);
	}

	function onServerDestroyed()
	{
		cancel($MiningLoop);
		cancel($Mining::AutoSave);
		cancel($Mining::AmbienceLoop);
		deactivatePackage(MiningPackage);
		deleteVariables("$Mining*");
		cancel($Mining::CheckBrickCount);
		cancel($MiningReset);
		$Mining::HasStarted = 0;
		$Mining::ExplosionsInProgress = 0;
		parent::onServerDestroyed();
	}

	function GameConnection::onDeath(%client,%obj,%killer,%type,%area)
	{
		serverPlay2D(ambience_death);

		%client.heatsuits -= getRandom(10,20);
		%client.radsuits -= getRandom(10,20);
		//%client.dirt -= getRandom(50,100);
		//%client.cash -= %client.level*getRandom(20,30);
		%client.dirt = math_Subtract(%client.dirt,getRandom(50,100));
		%client.cash = math_Subtract(%client.cash,%client.level * getRandom(20,30));

		if(%client.heatsuits < 0)
			%client.heatsuits = 0;
		if(%client.radsuits < 0)
			%client.radsuits = 0;
		if(%client.dirt < 0)
			%client.dirt = 0;

		parent::onDeath(%client,%obj,%killer,%type,%area);
	}

	function serverCmdPlantBrick(%client)
	{
		%tempbrick = %client.player.tempbrick;
		%brickgroup = "BrickGroup_" @ %client.bl_id;

		if(!isObject(%tempbrick))
			return;

		%brick = new fxDTSBrick()
		{
			angleID = %tempbrick.angleID;
			client = %client;
			colorFxID = %tempbrick.colorFxID;
			colorID = %tempbrick.colorID;
			dataBlock = %tempbrick.dataBlock;
			isBasePlate = %tempbrick.isBasePlate;
			isPlanted = 1;
			position = %tempbrick.getPosition();
			printID = %tempbrick.printID;
			rotation = %tempbrick.rotation;
			scale = "1 1 1";
			shapeFxID = %tempbrick.shapeFxID;
			stackBL_ID = "-1";
			buildArea = 1;
			buildArea_NormalBrick = 1;
		};

		if(%error = %brick.plant())
		{
			switch(%error)
			{
				case 1: %cmd = 'MsgPlantError_Overlap';
				case 2: %cmd = 'MsgPlantError_Float';
				case 3: %cmd = 'MsgPlantError_Stuck';
				case 4: %cmd = 'MsgPlantError_Unstable';
				case 5: %cmd = 'MsgPlantError_Buried';
				case 6: %cmd = 'MsgPlantError_TooFar';
				case 7: %cmd = 'MsgPlantError_TooLoud';
				case 8: %cmd = 'MsgPlantError_Limit';
			}
			
			%client.play2D(ErrorSound);
			messageClient(%client,%cmd);
			%brick.delete();
			
			return -1;
		}

		%numdown = %brick.getNumDownBricks();
		for(%i=0;%i<%numdown;%i++)
		{
			if(%brick.getDownBrick(%i).buildArea_NormalBrick)
				break;
			if(%brick.getDownBrick(%i).type !$= "Building Area" || %numdown < mFloor(%brick.dataBlock.brickSizeX/4) * mFloor(%brick.dataBlock.brickSizeY/4))
			{
				%client.centerPrint("<font:Impact:24>\c6You don't have enough build markers down to place this brick.",3);
				%client.play2D(MiningErrorSound);
				%brick.delete();
				return;
				break;
			}
		}
		//if(%numdown < (%brick.dataBlock.brickSizeX % 4) * (%brick.dataBlock.brickSizeY % 4))
		//{
		//	%client.centerPrint("<font:Impact:24>You don't have enough build markers down to place this brick.");
		//	%client.play2D(MiningErrorSound);
		//	%brick.delete();
		//	return;
		//}

		if(!isObject(%brick))
			return;

		%datablock = %tempbrick.dataBlock;
		%cost = (%datablock.brickSizeX * %datablock.brickSizeY * %datablock.brickSizeZ)/10;
		if(%client.cash < %cost)
		{
			%client.centerPrint("\c6<font:Impact:24>You need at least $" @ getCommaNumber(%cost,1) SPC "to place this brick. <br>See /help for the formula.");
			%client.play2D(MiningErrorSound);
			return;
		}
		else
		{
			%client.cash = math_Subtract(%client.cash,%cost);
			%client.centerPrint("<font:Impact:20>\c0-$" @ getCommaNumber(%cost,1),1);
			sendGUICommand(%client,"cash");
		}

		%brick.setTrusted(1);
		%brickgroup.add(%brick);

		%brick.playSound(brickPlantSound);
	}

	function fxDTSBrick::killBrick(%this)
	{
		if(%this.willCauseChainKill())
		{
			%this.delete();
			return;
		}
		parent::killBrick(%this);
	}

	function brickDeployProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
	{
		if(!isObject(%col))
			return;
		if(%col.getClassName() !$= "fxDTSBrick")
			return;

		if(%col.buildArea)
		{
			if(%col.planter)
			{
				if(!getTrustLevel(%obj.client,%col.planter))
				{
					%obj.client.centerPrint("<font:Impact:24>\c6" @ %col.lastOwner.name SPC "does not trust you enough to build with them.",2);
					%obj.client.play2D(miningErrorSound);
					return;
				}
			}
			else
			{
				if(!getTrustLevel(%obj.client,%col.client))
				{
					%obj.client.centerPrint("<font:Impact:24>\c6" @ %col.lastOwner.name SPC "does not trust you enough to build with them.",2);
					%obj.client.play2D(miningErrorSound);
					return;
				}
			}
			parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
		}
		else
		{
			%obj.client.centerPrint("<font:Impact:24>\c6This brick is not marked as your building area.",3);
			%obj.client.play2D(miningErrorSound);
		}
	}

	function HammerImage::onHitObject(%a,%obj,%c,%col,%e,%f)
	{
		if(!isObject(%col))
			return;

		%col.playSound(HammerHitSound);

		if(%col.mineable)
			return;

		if(!getTrustLevel(%obj.client,%col.client))
		{
			%obj.client.centerPrint("<font:Impact:24>\c6" @ %col.lastOwner.name SPC "does not trust you enough to build with them.",2);
			%obj.client.play2D(miningErrorSound);
			return;
		}

		%datablock = %col.getDatablock();
		%cost = (%datablock.brickSizeX * %datablock.brickSizeY * %datablock.brickSizeZ)/10;

		%col.client.cash = math_Add(%col.client.cash,%cost);
		sendGUICommand(%col.client,"cash");
		%col.client.centerPrint("<font:Impact:20>\c2+$" @ getCommaNumber(%cost,1),1);
		%col.playSound(BrickBreakSound);
		%col.killBrick();
	}

	function armor::onCollision(%this,%obj,%col,%a,%b,%c,%d)
	{
		if(%obj.getClassname() $= "AIPlayer" && getSimTime() > %col.lastAttacked && %obj.getState() !$= "Dead" && %col.getClassName() $= "Player")
		{
			%col.setHealth(100);
			if(%obj.getDatablock().getName() $= "RadZombieHoleBot")
			{
				decreasePlayerHealth(%col.client,getRandom(10,15));
				%col.lastAttacked = getSimTime() + 700;
			}
			if(%obj.getDatablock().getName() $= "ZombieHoleBot")
			{
				decreasePlayerHealth(%col.client,getRandom(7,12));
				%col.lastAttacked = getSimTime() + 1000;
			}
		}
		parent::onCollision(%this,%obj,%col,%a,%b,%c,%d);
	}

	function serverCmdSuicide(%client)
	{
		if(%client.player)
		{
			%temp = %client.player.health;
			%client.player.delete();
		}
		%client.spawnPlayer();
		%client.player.health = %temp;
		sendGUICommand(%client,"health");
	}

	function fxDTSBrick::setItem() { return; }

	function Player::activateStuff(%player)
	{
		parent::activateStuff(%player);

		%start = %player.getEyePoint();
		%direction  = %player.getEyeVector();
		%path = vectorScale(%direction,5);
		%stop = vectorAdd(%start,%path);
		%ray = containerRayCast(%start,%stop,$TypeMasks::All,%player);
		%col = firstWord(%ray);

		if(!isObject(%col))
			return;
		if(%col.getClassName() $= "fxDTSBrick" && %col.mineable)
		{
			%color = convertRGBtoHex(mFloor(getWord(getColorIdTable(%col.colorID),0) * 255));
			%color = %color @ convertRGBtoHex(mFloor(getWord(getColorIdTable(%col.colorID),1) * 255));
			%color = %color @ convertRGBtoHex(mFloor(getWord(getColorIdTable(%col.colorID),2) * 255));
			%color = "<color:" @ %color @ ">";
			if(%col.radiated)
				%type = "Radiated" SPC %col.type;
			else
				%type = %col.type;
			if(%col.value)
			{
				%cost = getWeightedCost(%player,%col);
				%player.client.centerPrint("<font:Impact:24>" @ %color @ %type @ "\c6: " @ getCommaNumber(%col.health) @ "/" @ getCommaNumber(%col.maxhealth) @ "<br><color:00ff00><font:Impact:18>Base Value\c6: $" @ getCommaNumber(%col.value,1) @ "<br><color:00ff99><font:Impact:20>Weighted Value\c6: $" @ getCommaNumber(%cost,1) SPC "\c7(" @ getAge(%col,1) @ ")",2);
			}
			else
				%player.client.centerPrint("<font:Impact:24>" @ %color @ %type @ "<color:ffffff>: " @ getCommaNumber(%col.health) @ "/" @ getCommaNumber(%col.maxhealth),2);
		}
		if(%col.getClassName() $= "Player")
			%player.client.centerPrint("<font:Impact:24><color:ffff00>" @ %col.client.name @ "<br><font:Impact:20><color:00ff00>Cash<color:ffffff>: $" @ getCommaNumber(%col.client.cash,1) @ "<br><color:ff0000>Health<color:ffffff>: " @ getCommaNumber(%col.health) SPC "/" SPC getCommaNumber(%col.client.maxHealth) @ "<br><color:00ffff>Score<color:ffffff>: " @ getCommaNumber(%col.client.points),2);
	}
};
activatePackage(MiningPackage);

function limitEvents()
{
	registerOutputEvent(fxDTSBrick,"radiusImpulse","");
	registerOutputEvent(fxDTSBrick,"setItem","");
	registerOutputEvent(fxDTSBrick,"setItemDirection","");
	registerOutputEvent(fxDTSBrick,"setItemPosition","");
	registerOutputEvent(fxDTSBrick,"spawnItem","");
	registerOutputEvent(fxDTSBrick,"spawnExplosion","");
	registerOutputEvent(fxDTSBrick,"spawnProjectile","");
	registerInputEvent(fxDTSBrick,"onActivate","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onBlownUp","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onBotActivated","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onBotDeath","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onBotReachBrick","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onBotTouch","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onMinigameReset","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onPlayerTouch","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onPrintCountOverFlow","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onPrintCountUnderFlow","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onProjectileHit","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onRelay","Self fxDTSBrick");
	registerInputEvent(fxDTSBrick,"onRespawn","Self fxDTSBrick");
}
limitEvents();

noticeMessage("Activated MiningPackage.");
		
exec($Mining::Root @ "pick.cs");
noticeMessage("Initiated the pickaxe.");

exec($Mining::Root @ "waterSpray.cs");
noticeMessage("Initiated the water spray.");

exec($Mining::Root @ "dirtPlacer.cs");
noticeMessage("Initiated the dirt placer.");

exec($Mining::Root @ "lanternPlacer.cs");
noticeMessage("Initiated the lantern placer.");

exec($Mining::Root @ "buildAreaPlacer.cs");
noticeMessage("Initiated the build area marker.");

exec($Mining::Root @ "dynamite.cs");
noticeMessage("Initiated dynamite.");

exec($Mining::Root @ "bot_zombierad.cs");
noticeMessage("Added radiated zombies.");

schedule(5000,0,miningInit);
noticeMessage("\c3Finished executing server.cs");