datablock ParticleData(M_WATERParticleC)
{
	dragCoefficient      = 0.0;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 75;
	textureName          = "base/data/particles/cloud";
	spinSpeed               = 30.0;
	spinRandomMin           = -30.0;
	spinRandomMax           = 30.0;
	useInvAlpha   = true;

	colors[0]     = "0.274 0.666 1 1";
	colors[1]     = "0.274 0.666 1 1";
	colors[2]     = "0.274 0.666 1 1";
	colors[3]     = "0.274 0.666 1 1";

	sizes[0]        = 0.0;
	sizes[1]        = 0.0;
	sizes[2]        = 0.5;
	sizes[3]        = 2.5;

	times[0]        = 0.0;
	times[1]        = 0.2;
	times[2]        = 0.8;
	times[3]        = 1.0;
};

datablock ParticleEmitterData(M_WATEREmitterC)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 25.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 5;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	orientOnVelocity = true;

	particles = M_WATERParticleC; 
};

datablock ExplosionData(M_WATERsprayExplosion)
{
	lifeTimeMS = 150;

	particleEmitter = PlayerFoamEmitter;
	particleDensity = 50;
	particleRadius = 0.2;

	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;

	lightStartRadius = 0;
	lightEndRadius = 2;
	lightStartColor = "0.6 0.6 0.9";
	lightEndColor = "0 0 0";
};

datablock ProjectileData(M_WATERsprayProjectile)
{

	directDamage        = 0;
	directDamageType    = $DamageType::ArrowDirect;

	radiusDamage        = 0;
	damageRadius        = 0;
	radiusDamageType    = $DamageType::ArrowDirect;

	explosion           = M_WATERsprayExplosion;

	muzzleVelocity      = 20;
	velInheritFactor    = 0;

	armingDelay         = 0;
	lifetime            = 500;
	fadeDelay           = 250;
	bounceElasticity    = 0;
	bounceFriction      = 0;
	isBallistic         = false;
	gravityMod = 0.0;

	hasLight    = false;
};

datablock ItemData(WaterSprayItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "base/data/shapes/sprayCan.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Water Spray";
	iconName = "base/client/ui/PaintLabel.png";
	doColorShift = true;
	colorShiftColor = "0.274 0.666 1 1";

	image = M_WATERsprayImage;
	canDrop = true;
};

datablock ShapeBaseImageData(M_WATERsprayImage)
{
	shapeFile = "base/data/shapes/sprayCan.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );
	correctMuzzleVector = true;

	className = "WeaponImage";
	item = WaterSprayItem;
	ammo = " ";
	projectile = M_WATERsprayProjectile;
	projectileType = Projectile;
	casing = "";
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;     
	shellVelocity       = 7.0;
	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = WaterSprayItem.colorShiftColor;

	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.15;
	stateTransitionOnTimeout[0] = "Ready";
	stateSound[0] = weaponSwitchSound;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1] = true;
	stateSequence[1] = "Ready";

	stateName[2] = "Fire";
	stateTransitionOnTimeout[2] = "Fire";
	stateTransitionOnTriggerUp[2] = "Reload";
	stateTimeoutValue[2] = 1.00;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateSequence[2] = "Fire";
	stateScript[2] = "onFire";
	stateWaitForTimeout[2] = true;
	stateEmitter[2] = M_WATEREmitterC;
	stateEmitterTime[2] = 0.05;
	stateEmitterNode[2] = "muzzleNode";
	stateSound[2] = sprayFireSound;
	stateEjectShell[2] = true;


	stateName[3] = "Reload";
	stateSequence[3] = "Reload";
	stateTransitionOnTriggerUp[3] = "Ready";
	stateTransitionOnTriggerDown[3] = "Fire";
	stateSequence[3] = "Ready";

};

function M_WATERsprayProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.type $= "Lava")
	{
		checkMiningBlock(%col.getPosition());
		%col.delete();
	}
}